#ifndef _H_96A138A13EE2BB35F544151D697893F4_Dock_DCPS_H_
#define _H_96A138A13EE2BB35F544151D697893F4_Dock_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Dock_.h"


namespace py_trees_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            class Dock_Goal_TypeSupportInterface;

            typedef Dock_Goal_TypeSupportInterface * Dock_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_Goal_TypeSupportInterface> Dock_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_Goal_TypeSupportInterface> Dock_Goal_TypeSupportInterface_out;


            class Dock_Goal_DataWriter;

            typedef Dock_Goal_DataWriter * Dock_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_Goal_DataWriter> Dock_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_Goal_DataWriter> Dock_Goal_DataWriter_out;


            class Dock_Goal_DataReader;

            typedef Dock_Goal_DataReader * Dock_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_Goal_DataReader> Dock_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_Goal_DataReader> Dock_Goal_DataReader_out;


            class Dock_Goal_DataReaderView;

            typedef Dock_Goal_DataReaderView * Dock_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_Goal_DataReaderView> Dock_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_Goal_DataReaderView> Dock_Goal_DataReaderView_out;

            struct Dock_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dock_Goal_, struct Dock_Goal_Seq_uniq_> Dock_Goal_Seq;
            typedef DDS_DCPSSequence_var < Dock_Goal_Seq> Dock_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_Goal_Seq> Dock_Goal_Seq_out;

            class  Dock_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_Goal_TypeSupportInterface_var _var_type;

                static Dock_Goal_TypeSupportInterface_ptr _duplicate (Dock_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_Goal_TypeSupportInterface () {};
                ~Dock_Goal_TypeSupportInterface () {};
            private:
                Dock_Goal_TypeSupportInterface (const Dock_Goal_TypeSupportInterface &);
                Dock_Goal_TypeSupportInterface & operator = (const Dock_Goal_TypeSupportInterface &);
            };

            class  Dock_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_Goal_DataWriter_ptr _ptr_type;
                typedef Dock_Goal_DataWriter_var _var_type;

                static Dock_Goal_DataWriter_ptr _duplicate (Dock_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Goal_& instance_data) = 0;

            protected:
                Dock_Goal_DataWriter () {};
                ~Dock_Goal_DataWriter () {};
            private:
                Dock_Goal_DataWriter (const Dock_Goal_DataWriter &);
                Dock_Goal_DataWriter & operator = (const Dock_Goal_DataWriter &);
            };

            class  Dock_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_Goal_DataReader_ptr _ptr_type;
                typedef Dock_Goal_DataReader_var _var_type;

                static Dock_Goal_DataReader_ptr _duplicate (Dock_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Goal_& instance) = 0;

            protected:
                Dock_Goal_DataReader () {};
                ~Dock_Goal_DataReader () {};
            private:
                Dock_Goal_DataReader (const Dock_Goal_DataReader &);
                Dock_Goal_DataReader & operator = (const Dock_Goal_DataReader &);
            };

            class  Dock_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_Goal_DataReaderView_ptr _ptr_type;
                typedef Dock_Goal_DataReaderView_var _var_type;

                static Dock_Goal_DataReaderView_ptr _duplicate (Dock_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Goal_& instance) = 0;

            protected:
                Dock_Goal_DataReaderView () {};
                ~Dock_Goal_DataReaderView () {};
            private:
                Dock_Goal_DataReaderView (const Dock_Goal_DataReaderView &);
                Dock_Goal_DataReaderView & operator = (const Dock_Goal_DataReaderView &);
            };
            class Dock_SendGoal_Request_TypeSupportInterface;

            typedef Dock_SendGoal_Request_TypeSupportInterface * Dock_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Request_TypeSupportInterface> Dock_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Request_TypeSupportInterface> Dock_SendGoal_Request_TypeSupportInterface_out;


            class Dock_SendGoal_Request_DataWriter;

            typedef Dock_SendGoal_Request_DataWriter * Dock_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Request_DataWriter> Dock_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Request_DataWriter> Dock_SendGoal_Request_DataWriter_out;


            class Dock_SendGoal_Request_DataReader;

            typedef Dock_SendGoal_Request_DataReader * Dock_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Request_DataReader> Dock_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Request_DataReader> Dock_SendGoal_Request_DataReader_out;


            class Dock_SendGoal_Request_DataReaderView;

            typedef Dock_SendGoal_Request_DataReaderView * Dock_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Request_DataReaderView> Dock_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Request_DataReaderView> Dock_SendGoal_Request_DataReaderView_out;

            struct Dock_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dock_SendGoal_Request_, struct Dock_SendGoal_Request_Seq_uniq_> Dock_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Dock_SendGoal_Request_Seq> Dock_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_SendGoal_Request_Seq> Dock_SendGoal_Request_Seq_out;

            class  Dock_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Dock_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Dock_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_SendGoal_Request_TypeSupportInterface () {};
                ~Dock_SendGoal_Request_TypeSupportInterface () {};
            private:
                Dock_SendGoal_Request_TypeSupportInterface (const Dock_SendGoal_Request_TypeSupportInterface &);
                Dock_SendGoal_Request_TypeSupportInterface & operator = (const Dock_SendGoal_Request_TypeSupportInterface &);
            };

            class  Dock_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Dock_SendGoal_Request_DataWriter_var _var_type;

                static Dock_SendGoal_Request_DataWriter_ptr _duplicate (Dock_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_SendGoal_Request_& instance_data) = 0;

            protected:
                Dock_SendGoal_Request_DataWriter () {};
                ~Dock_SendGoal_Request_DataWriter () {};
            private:
                Dock_SendGoal_Request_DataWriter (const Dock_SendGoal_Request_DataWriter &);
                Dock_SendGoal_Request_DataWriter & operator = (const Dock_SendGoal_Request_DataWriter &);
            };

            class  Dock_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Dock_SendGoal_Request_DataReader_var _var_type;

                static Dock_SendGoal_Request_DataReader_ptr _duplicate (Dock_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_SendGoal_Request_& instance) = 0;

            protected:
                Dock_SendGoal_Request_DataReader () {};
                ~Dock_SendGoal_Request_DataReader () {};
            private:
                Dock_SendGoal_Request_DataReader (const Dock_SendGoal_Request_DataReader &);
                Dock_SendGoal_Request_DataReader & operator = (const Dock_SendGoal_Request_DataReader &);
            };

            class  Dock_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Dock_SendGoal_Request_DataReaderView_var _var_type;

                static Dock_SendGoal_Request_DataReaderView_ptr _duplicate (Dock_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_SendGoal_Request_& instance) = 0;

            protected:
                Dock_SendGoal_Request_DataReaderView () {};
                ~Dock_SendGoal_Request_DataReaderView () {};
            private:
                Dock_SendGoal_Request_DataReaderView (const Dock_SendGoal_Request_DataReaderView &);
                Dock_SendGoal_Request_DataReaderView & operator = (const Dock_SendGoal_Request_DataReaderView &);
            };
            class Dock_SendGoal_Response_TypeSupportInterface;

            typedef Dock_SendGoal_Response_TypeSupportInterface * Dock_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Response_TypeSupportInterface> Dock_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Response_TypeSupportInterface> Dock_SendGoal_Response_TypeSupportInterface_out;


            class Dock_SendGoal_Response_DataWriter;

            typedef Dock_SendGoal_Response_DataWriter * Dock_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Response_DataWriter> Dock_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Response_DataWriter> Dock_SendGoal_Response_DataWriter_out;


            class Dock_SendGoal_Response_DataReader;

            typedef Dock_SendGoal_Response_DataReader * Dock_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Response_DataReader> Dock_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Response_DataReader> Dock_SendGoal_Response_DataReader_out;


            class Dock_SendGoal_Response_DataReaderView;

            typedef Dock_SendGoal_Response_DataReaderView * Dock_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_SendGoal_Response_DataReaderView> Dock_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_SendGoal_Response_DataReaderView> Dock_SendGoal_Response_DataReaderView_out;

            struct Dock_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dock_SendGoal_Response_, struct Dock_SendGoal_Response_Seq_uniq_> Dock_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Dock_SendGoal_Response_Seq> Dock_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_SendGoal_Response_Seq> Dock_SendGoal_Response_Seq_out;

            class  Dock_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Dock_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Dock_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_SendGoal_Response_TypeSupportInterface () {};
                ~Dock_SendGoal_Response_TypeSupportInterface () {};
            private:
                Dock_SendGoal_Response_TypeSupportInterface (const Dock_SendGoal_Response_TypeSupportInterface &);
                Dock_SendGoal_Response_TypeSupportInterface & operator = (const Dock_SendGoal_Response_TypeSupportInterface &);
            };

            class  Dock_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Dock_SendGoal_Response_DataWriter_var _var_type;

                static Dock_SendGoal_Response_DataWriter_ptr _duplicate (Dock_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_SendGoal_Response_& instance_data) = 0;

            protected:
                Dock_SendGoal_Response_DataWriter () {};
                ~Dock_SendGoal_Response_DataWriter () {};
            private:
                Dock_SendGoal_Response_DataWriter (const Dock_SendGoal_Response_DataWriter &);
                Dock_SendGoal_Response_DataWriter & operator = (const Dock_SendGoal_Response_DataWriter &);
            };

            class  Dock_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Dock_SendGoal_Response_DataReader_var _var_type;

                static Dock_SendGoal_Response_DataReader_ptr _duplicate (Dock_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_SendGoal_Response_& instance) = 0;

            protected:
                Dock_SendGoal_Response_DataReader () {};
                ~Dock_SendGoal_Response_DataReader () {};
            private:
                Dock_SendGoal_Response_DataReader (const Dock_SendGoal_Response_DataReader &);
                Dock_SendGoal_Response_DataReader & operator = (const Dock_SendGoal_Response_DataReader &);
            };

            class  Dock_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Dock_SendGoal_Response_DataReaderView_var _var_type;

                static Dock_SendGoal_Response_DataReaderView_ptr _duplicate (Dock_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_SendGoal_Response_& instance) = 0;

            protected:
                Dock_SendGoal_Response_DataReaderView () {};
                ~Dock_SendGoal_Response_DataReaderView () {};
            private:
                Dock_SendGoal_Response_DataReaderView (const Dock_SendGoal_Response_DataReaderView &);
                Dock_SendGoal_Response_DataReaderView & operator = (const Dock_SendGoal_Response_DataReaderView &);
            };
            class Sample_Dock_SendGoal_Request_TypeSupportInterface;

            typedef Sample_Dock_SendGoal_Request_TypeSupportInterface * Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Request_TypeSupportInterface> Sample_Dock_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Request_TypeSupportInterface> Sample_Dock_SendGoal_Request_TypeSupportInterface_out;


            class Sample_Dock_SendGoal_Request_DataWriter;

            typedef Sample_Dock_SendGoal_Request_DataWriter * Sample_Dock_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Request_DataWriter> Sample_Dock_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Request_DataWriter> Sample_Dock_SendGoal_Request_DataWriter_out;


            class Sample_Dock_SendGoal_Request_DataReader;

            typedef Sample_Dock_SendGoal_Request_DataReader * Sample_Dock_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Request_DataReader> Sample_Dock_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Request_DataReader> Sample_Dock_SendGoal_Request_DataReader_out;


            class Sample_Dock_SendGoal_Request_DataReaderView;

            typedef Sample_Dock_SendGoal_Request_DataReaderView * Sample_Dock_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Request_DataReaderView> Sample_Dock_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Request_DataReaderView> Sample_Dock_SendGoal_Request_DataReaderView_out;

            struct Sample_Dock_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Dock_SendGoal_Request_, struct Sample_Dock_SendGoal_Request_Seq_uniq_> Sample_Dock_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Dock_SendGoal_Request_Seq> Sample_Dock_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Dock_SendGoal_Request_Seq> Sample_Dock_SendGoal_Request_Seq_out;

            class  Sample_Dock_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Dock_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_Dock_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_Dock_SendGoal_Request_TypeSupportInterface (const Sample_Dock_SendGoal_Request_TypeSupportInterface &);
                Sample_Dock_SendGoal_Request_TypeSupportInterface & operator = (const Sample_Dock_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_Dock_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Dock_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Request_DataWriter_var _var_type;

                static Sample_Dock_SendGoal_Request_DataWriter_ptr _duplicate (Sample_Dock_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Dock_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Dock_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Dock_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_Dock_SendGoal_Request_DataWriter () {};
                ~Sample_Dock_SendGoal_Request_DataWriter () {};
            private:
                Sample_Dock_SendGoal_Request_DataWriter (const Sample_Dock_SendGoal_Request_DataWriter &);
                Sample_Dock_SendGoal_Request_DataWriter & operator = (const Sample_Dock_SendGoal_Request_DataWriter &);
            };

            class  Sample_Dock_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Dock_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Request_DataReader_var _var_type;

                static Sample_Dock_SendGoal_Request_DataReader_ptr _duplicate (Sample_Dock_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Dock_SendGoal_Request_DataReader () {};
                ~Sample_Dock_SendGoal_Request_DataReader () {};
            private:
                Sample_Dock_SendGoal_Request_DataReader (const Sample_Dock_SendGoal_Request_DataReader &);
                Sample_Dock_SendGoal_Request_DataReader & operator = (const Sample_Dock_SendGoal_Request_DataReader &);
            };

            class  Sample_Dock_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Dock_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_Dock_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_Dock_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Dock_SendGoal_Request_DataReaderView () {};
                ~Sample_Dock_SendGoal_Request_DataReaderView () {};
            private:
                Sample_Dock_SendGoal_Request_DataReaderView (const Sample_Dock_SendGoal_Request_DataReaderView &);
                Sample_Dock_SendGoal_Request_DataReaderView & operator = (const Sample_Dock_SendGoal_Request_DataReaderView &);
            };
            class Sample_Dock_SendGoal_Response_TypeSupportInterface;

            typedef Sample_Dock_SendGoal_Response_TypeSupportInterface * Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Response_TypeSupportInterface> Sample_Dock_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Response_TypeSupportInterface> Sample_Dock_SendGoal_Response_TypeSupportInterface_out;


            class Sample_Dock_SendGoal_Response_DataWriter;

            typedef Sample_Dock_SendGoal_Response_DataWriter * Sample_Dock_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Response_DataWriter> Sample_Dock_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Response_DataWriter> Sample_Dock_SendGoal_Response_DataWriter_out;


            class Sample_Dock_SendGoal_Response_DataReader;

            typedef Sample_Dock_SendGoal_Response_DataReader * Sample_Dock_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Response_DataReader> Sample_Dock_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Response_DataReader> Sample_Dock_SendGoal_Response_DataReader_out;


            class Sample_Dock_SendGoal_Response_DataReaderView;

            typedef Sample_Dock_SendGoal_Response_DataReaderView * Sample_Dock_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_SendGoal_Response_DataReaderView> Sample_Dock_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_SendGoal_Response_DataReaderView> Sample_Dock_SendGoal_Response_DataReaderView_out;

            struct Sample_Dock_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Dock_SendGoal_Response_, struct Sample_Dock_SendGoal_Response_Seq_uniq_> Sample_Dock_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Dock_SendGoal_Response_Seq> Sample_Dock_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Dock_SendGoal_Response_Seq> Sample_Dock_SendGoal_Response_Seq_out;

            class  Sample_Dock_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Dock_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_Dock_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_Dock_SendGoal_Response_TypeSupportInterface (const Sample_Dock_SendGoal_Response_TypeSupportInterface &);
                Sample_Dock_SendGoal_Response_TypeSupportInterface & operator = (const Sample_Dock_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_Dock_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Dock_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Response_DataWriter_var _var_type;

                static Sample_Dock_SendGoal_Response_DataWriter_ptr _duplicate (Sample_Dock_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Dock_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Dock_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Dock_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_Dock_SendGoal_Response_DataWriter () {};
                ~Sample_Dock_SendGoal_Response_DataWriter () {};
            private:
                Sample_Dock_SendGoal_Response_DataWriter (const Sample_Dock_SendGoal_Response_DataWriter &);
                Sample_Dock_SendGoal_Response_DataWriter & operator = (const Sample_Dock_SendGoal_Response_DataWriter &);
            };

            class  Sample_Dock_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Dock_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Response_DataReader_var _var_type;

                static Sample_Dock_SendGoal_Response_DataReader_ptr _duplicate (Sample_Dock_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Dock_SendGoal_Response_DataReader () {};
                ~Sample_Dock_SendGoal_Response_DataReader () {};
            private:
                Sample_Dock_SendGoal_Response_DataReader (const Sample_Dock_SendGoal_Response_DataReader &);
                Sample_Dock_SendGoal_Response_DataReader & operator = (const Sample_Dock_SendGoal_Response_DataReader &);
            };

            class  Sample_Dock_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Dock_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Dock_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_Dock_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_Dock_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Dock_SendGoal_Response_DataReaderView () {};
                ~Sample_Dock_SendGoal_Response_DataReaderView () {};
            private:
                Sample_Dock_SendGoal_Response_DataReaderView (const Sample_Dock_SendGoal_Response_DataReaderView &);
                Sample_Dock_SendGoal_Response_DataReaderView & operator = (const Sample_Dock_SendGoal_Response_DataReaderView &);
            };
            class Dock_Result_TypeSupportInterface;

            typedef Dock_Result_TypeSupportInterface * Dock_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_Result_TypeSupportInterface> Dock_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_Result_TypeSupportInterface> Dock_Result_TypeSupportInterface_out;


            class Dock_Result_DataWriter;

            typedef Dock_Result_DataWriter * Dock_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_Result_DataWriter> Dock_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_Result_DataWriter> Dock_Result_DataWriter_out;


            class Dock_Result_DataReader;

            typedef Dock_Result_DataReader * Dock_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_Result_DataReader> Dock_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_Result_DataReader> Dock_Result_DataReader_out;


            class Dock_Result_DataReaderView;

            typedef Dock_Result_DataReaderView * Dock_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_Result_DataReaderView> Dock_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_Result_DataReaderView> Dock_Result_DataReaderView_out;

            struct Dock_Result_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Dock_Result_, struct Dock_Result_Seq_uniq_> Dock_Result_Seq;
            typedef DDS_DCPSSequence_var < Dock_Result_Seq> Dock_Result_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_Result_Seq> Dock_Result_Seq_out;

            class  Dock_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_Result_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_Result_TypeSupportInterface_var _var_type;

                static Dock_Result_TypeSupportInterface_ptr _duplicate (Dock_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_Result_TypeSupportInterface () {};
                ~Dock_Result_TypeSupportInterface () {};
            private:
                Dock_Result_TypeSupportInterface (const Dock_Result_TypeSupportInterface &);
                Dock_Result_TypeSupportInterface & operator = (const Dock_Result_TypeSupportInterface &);
            };

            class  Dock_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_Result_DataWriter_ptr _ptr_type;
                typedef Dock_Result_DataWriter_var _var_type;

                static Dock_Result_DataWriter_ptr _duplicate (Dock_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Result_& instance_data) = 0;

            protected:
                Dock_Result_DataWriter () {};
                ~Dock_Result_DataWriter () {};
            private:
                Dock_Result_DataWriter (const Dock_Result_DataWriter &);
                Dock_Result_DataWriter & operator = (const Dock_Result_DataWriter &);
            };

            class  Dock_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_Result_DataReader_ptr _ptr_type;
                typedef Dock_Result_DataReader_var _var_type;

                static Dock_Result_DataReader_ptr _duplicate (Dock_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Result_& instance) = 0;

            protected:
                Dock_Result_DataReader () {};
                ~Dock_Result_DataReader () {};
            private:
                Dock_Result_DataReader (const Dock_Result_DataReader &);
                Dock_Result_DataReader & operator = (const Dock_Result_DataReader &);
            };

            class  Dock_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_Result_DataReaderView_ptr _ptr_type;
                typedef Dock_Result_DataReaderView_var _var_type;

                static Dock_Result_DataReaderView_ptr _duplicate (Dock_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Result_& instance) = 0;

            protected:
                Dock_Result_DataReaderView () {};
                ~Dock_Result_DataReaderView () {};
            private:
                Dock_Result_DataReaderView (const Dock_Result_DataReaderView &);
                Dock_Result_DataReaderView & operator = (const Dock_Result_DataReaderView &);
            };
            class Dock_GetResult_Request_TypeSupportInterface;

            typedef Dock_GetResult_Request_TypeSupportInterface * Dock_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Request_TypeSupportInterface> Dock_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Request_TypeSupportInterface> Dock_GetResult_Request_TypeSupportInterface_out;


            class Dock_GetResult_Request_DataWriter;

            typedef Dock_GetResult_Request_DataWriter * Dock_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Request_DataWriter> Dock_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Request_DataWriter> Dock_GetResult_Request_DataWriter_out;


            class Dock_GetResult_Request_DataReader;

            typedef Dock_GetResult_Request_DataReader * Dock_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Request_DataReader> Dock_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Request_DataReader> Dock_GetResult_Request_DataReader_out;


            class Dock_GetResult_Request_DataReaderView;

            typedef Dock_GetResult_Request_DataReaderView * Dock_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Request_DataReaderView> Dock_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Request_DataReaderView> Dock_GetResult_Request_DataReaderView_out;

            struct Dock_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dock_GetResult_Request_, struct Dock_GetResult_Request_Seq_uniq_> Dock_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Dock_GetResult_Request_Seq> Dock_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_GetResult_Request_Seq> Dock_GetResult_Request_Seq_out;

            class  Dock_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_GetResult_Request_TypeSupportInterface_var _var_type;

                static Dock_GetResult_Request_TypeSupportInterface_ptr _duplicate (Dock_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_GetResult_Request_TypeSupportInterface () {};
                ~Dock_GetResult_Request_TypeSupportInterface () {};
            private:
                Dock_GetResult_Request_TypeSupportInterface (const Dock_GetResult_Request_TypeSupportInterface &);
                Dock_GetResult_Request_TypeSupportInterface & operator = (const Dock_GetResult_Request_TypeSupportInterface &);
            };

            class  Dock_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Dock_GetResult_Request_DataWriter_var _var_type;

                static Dock_GetResult_Request_DataWriter_ptr _duplicate (Dock_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_GetResult_Request_& instance_data) = 0;

            protected:
                Dock_GetResult_Request_DataWriter () {};
                ~Dock_GetResult_Request_DataWriter () {};
            private:
                Dock_GetResult_Request_DataWriter (const Dock_GetResult_Request_DataWriter &);
                Dock_GetResult_Request_DataWriter & operator = (const Dock_GetResult_Request_DataWriter &);
            };

            class  Dock_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Dock_GetResult_Request_DataReader_var _var_type;

                static Dock_GetResult_Request_DataReader_ptr _duplicate (Dock_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_GetResult_Request_& instance) = 0;

            protected:
                Dock_GetResult_Request_DataReader () {};
                ~Dock_GetResult_Request_DataReader () {};
            private:
                Dock_GetResult_Request_DataReader (const Dock_GetResult_Request_DataReader &);
                Dock_GetResult_Request_DataReader & operator = (const Dock_GetResult_Request_DataReader &);
            };

            class  Dock_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Dock_GetResult_Request_DataReaderView_var _var_type;

                static Dock_GetResult_Request_DataReaderView_ptr _duplicate (Dock_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_GetResult_Request_& instance) = 0;

            protected:
                Dock_GetResult_Request_DataReaderView () {};
                ~Dock_GetResult_Request_DataReaderView () {};
            private:
                Dock_GetResult_Request_DataReaderView (const Dock_GetResult_Request_DataReaderView &);
                Dock_GetResult_Request_DataReaderView & operator = (const Dock_GetResult_Request_DataReaderView &);
            };
            class Dock_GetResult_Response_TypeSupportInterface;

            typedef Dock_GetResult_Response_TypeSupportInterface * Dock_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Response_TypeSupportInterface> Dock_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Response_TypeSupportInterface> Dock_GetResult_Response_TypeSupportInterface_out;


            class Dock_GetResult_Response_DataWriter;

            typedef Dock_GetResult_Response_DataWriter * Dock_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Response_DataWriter> Dock_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Response_DataWriter> Dock_GetResult_Response_DataWriter_out;


            class Dock_GetResult_Response_DataReader;

            typedef Dock_GetResult_Response_DataReader * Dock_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Response_DataReader> Dock_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Response_DataReader> Dock_GetResult_Response_DataReader_out;


            class Dock_GetResult_Response_DataReaderView;

            typedef Dock_GetResult_Response_DataReaderView * Dock_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_GetResult_Response_DataReaderView> Dock_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_GetResult_Response_DataReaderView> Dock_GetResult_Response_DataReaderView_out;

            struct Dock_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Dock_GetResult_Response_, struct Dock_GetResult_Response_Seq_uniq_> Dock_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Dock_GetResult_Response_Seq> Dock_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_GetResult_Response_Seq> Dock_GetResult_Response_Seq_out;

            class  Dock_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_GetResult_Response_TypeSupportInterface_var _var_type;

                static Dock_GetResult_Response_TypeSupportInterface_ptr _duplicate (Dock_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_GetResult_Response_TypeSupportInterface () {};
                ~Dock_GetResult_Response_TypeSupportInterface () {};
            private:
                Dock_GetResult_Response_TypeSupportInterface (const Dock_GetResult_Response_TypeSupportInterface &);
                Dock_GetResult_Response_TypeSupportInterface & operator = (const Dock_GetResult_Response_TypeSupportInterface &);
            };

            class  Dock_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Dock_GetResult_Response_DataWriter_var _var_type;

                static Dock_GetResult_Response_DataWriter_ptr _duplicate (Dock_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_GetResult_Response_& instance_data) = 0;

            protected:
                Dock_GetResult_Response_DataWriter () {};
                ~Dock_GetResult_Response_DataWriter () {};
            private:
                Dock_GetResult_Response_DataWriter (const Dock_GetResult_Response_DataWriter &);
                Dock_GetResult_Response_DataWriter & operator = (const Dock_GetResult_Response_DataWriter &);
            };

            class  Dock_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Dock_GetResult_Response_DataReader_var _var_type;

                static Dock_GetResult_Response_DataReader_ptr _duplicate (Dock_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_GetResult_Response_& instance) = 0;

            protected:
                Dock_GetResult_Response_DataReader () {};
                ~Dock_GetResult_Response_DataReader () {};
            private:
                Dock_GetResult_Response_DataReader (const Dock_GetResult_Response_DataReader &);
                Dock_GetResult_Response_DataReader & operator = (const Dock_GetResult_Response_DataReader &);
            };

            class  Dock_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Dock_GetResult_Response_DataReaderView_var _var_type;

                static Dock_GetResult_Response_DataReaderView_ptr _duplicate (Dock_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_GetResult_Response_& instance) = 0;

            protected:
                Dock_GetResult_Response_DataReaderView () {};
                ~Dock_GetResult_Response_DataReaderView () {};
            private:
                Dock_GetResult_Response_DataReaderView (const Dock_GetResult_Response_DataReaderView &);
                Dock_GetResult_Response_DataReaderView & operator = (const Dock_GetResult_Response_DataReaderView &);
            };
            class Sample_Dock_GetResult_Request_TypeSupportInterface;

            typedef Sample_Dock_GetResult_Request_TypeSupportInterface * Sample_Dock_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Request_TypeSupportInterface> Sample_Dock_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Request_TypeSupportInterface> Sample_Dock_GetResult_Request_TypeSupportInterface_out;


            class Sample_Dock_GetResult_Request_DataWriter;

            typedef Sample_Dock_GetResult_Request_DataWriter * Sample_Dock_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Request_DataWriter> Sample_Dock_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Request_DataWriter> Sample_Dock_GetResult_Request_DataWriter_out;


            class Sample_Dock_GetResult_Request_DataReader;

            typedef Sample_Dock_GetResult_Request_DataReader * Sample_Dock_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Request_DataReader> Sample_Dock_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Request_DataReader> Sample_Dock_GetResult_Request_DataReader_out;


            class Sample_Dock_GetResult_Request_DataReaderView;

            typedef Sample_Dock_GetResult_Request_DataReaderView * Sample_Dock_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Request_DataReaderView> Sample_Dock_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Request_DataReaderView> Sample_Dock_GetResult_Request_DataReaderView_out;

            struct Sample_Dock_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Dock_GetResult_Request_, struct Sample_Dock_GetResult_Request_Seq_uniq_> Sample_Dock_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Dock_GetResult_Request_Seq> Sample_Dock_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Dock_GetResult_Request_Seq> Sample_Dock_GetResult_Request_Seq_out;

            class  Sample_Dock_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Dock_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_Dock_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_Dock_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Dock_GetResult_Request_TypeSupportInterface () {};
                ~Sample_Dock_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_Dock_GetResult_Request_TypeSupportInterface (const Sample_Dock_GetResult_Request_TypeSupportInterface &);
                Sample_Dock_GetResult_Request_TypeSupportInterface & operator = (const Sample_Dock_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_Dock_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Dock_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Request_DataWriter_var _var_type;

                static Sample_Dock_GetResult_Request_DataWriter_ptr _duplicate (Sample_Dock_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Dock_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Dock_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Dock_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_Dock_GetResult_Request_DataWriter () {};
                ~Sample_Dock_GetResult_Request_DataWriter () {};
            private:
                Sample_Dock_GetResult_Request_DataWriter (const Sample_Dock_GetResult_Request_DataWriter &);
                Sample_Dock_GetResult_Request_DataWriter & operator = (const Sample_Dock_GetResult_Request_DataWriter &);
            };

            class  Sample_Dock_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Dock_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Request_DataReader_var _var_type;

                static Sample_Dock_GetResult_Request_DataReader_ptr _duplicate (Sample_Dock_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_GetResult_Request_& instance) = 0;

            protected:
                Sample_Dock_GetResult_Request_DataReader () {};
                ~Sample_Dock_GetResult_Request_DataReader () {};
            private:
                Sample_Dock_GetResult_Request_DataReader (const Sample_Dock_GetResult_Request_DataReader &);
                Sample_Dock_GetResult_Request_DataReader & operator = (const Sample_Dock_GetResult_Request_DataReader &);
            };

            class  Sample_Dock_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Dock_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Request_DataReaderView_var _var_type;

                static Sample_Dock_GetResult_Request_DataReaderView_ptr _duplicate (Sample_Dock_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_GetResult_Request_& instance) = 0;

            protected:
                Sample_Dock_GetResult_Request_DataReaderView () {};
                ~Sample_Dock_GetResult_Request_DataReaderView () {};
            private:
                Sample_Dock_GetResult_Request_DataReaderView (const Sample_Dock_GetResult_Request_DataReaderView &);
                Sample_Dock_GetResult_Request_DataReaderView & operator = (const Sample_Dock_GetResult_Request_DataReaderView &);
            };
            class Sample_Dock_GetResult_Response_TypeSupportInterface;

            typedef Sample_Dock_GetResult_Response_TypeSupportInterface * Sample_Dock_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Response_TypeSupportInterface> Sample_Dock_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Response_TypeSupportInterface> Sample_Dock_GetResult_Response_TypeSupportInterface_out;


            class Sample_Dock_GetResult_Response_DataWriter;

            typedef Sample_Dock_GetResult_Response_DataWriter * Sample_Dock_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Response_DataWriter> Sample_Dock_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Response_DataWriter> Sample_Dock_GetResult_Response_DataWriter_out;


            class Sample_Dock_GetResult_Response_DataReader;

            typedef Sample_Dock_GetResult_Response_DataReader * Sample_Dock_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Response_DataReader> Sample_Dock_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Response_DataReader> Sample_Dock_GetResult_Response_DataReader_out;


            class Sample_Dock_GetResult_Response_DataReaderView;

            typedef Sample_Dock_GetResult_Response_DataReaderView * Sample_Dock_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Dock_GetResult_Response_DataReaderView> Sample_Dock_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Dock_GetResult_Response_DataReaderView> Sample_Dock_GetResult_Response_DataReaderView_out;

            struct Sample_Dock_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Dock_GetResult_Response_, struct Sample_Dock_GetResult_Response_Seq_uniq_> Sample_Dock_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Dock_GetResult_Response_Seq> Sample_Dock_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Dock_GetResult_Response_Seq> Sample_Dock_GetResult_Response_Seq_out;

            class  Sample_Dock_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Dock_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_Dock_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_Dock_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Dock_GetResult_Response_TypeSupportInterface () {};
                ~Sample_Dock_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_Dock_GetResult_Response_TypeSupportInterface (const Sample_Dock_GetResult_Response_TypeSupportInterface &);
                Sample_Dock_GetResult_Response_TypeSupportInterface & operator = (const Sample_Dock_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_Dock_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Dock_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Response_DataWriter_var _var_type;

                static Sample_Dock_GetResult_Response_DataWriter_ptr _duplicate (Sample_Dock_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Dock_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Dock_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Dock_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_Dock_GetResult_Response_DataWriter () {};
                ~Sample_Dock_GetResult_Response_DataWriter () {};
            private:
                Sample_Dock_GetResult_Response_DataWriter (const Sample_Dock_GetResult_Response_DataWriter &);
                Sample_Dock_GetResult_Response_DataWriter & operator = (const Sample_Dock_GetResult_Response_DataWriter &);
            };

            class  Sample_Dock_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Dock_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Response_DataReader_var _var_type;

                static Sample_Dock_GetResult_Response_DataReader_ptr _duplicate (Sample_Dock_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_GetResult_Response_& instance) = 0;

            protected:
                Sample_Dock_GetResult_Response_DataReader () {};
                ~Sample_Dock_GetResult_Response_DataReader () {};
            private:
                Sample_Dock_GetResult_Response_DataReader (const Sample_Dock_GetResult_Response_DataReader &);
                Sample_Dock_GetResult_Response_DataReader & operator = (const Sample_Dock_GetResult_Response_DataReader &);
            };

            class  Sample_Dock_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Dock_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Dock_GetResult_Response_DataReaderView_var _var_type;

                static Sample_Dock_GetResult_Response_DataReaderView_ptr _duplicate (Sample_Dock_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Dock_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Dock_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Dock_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Dock_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Dock_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Dock_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Dock_GetResult_Response_& instance) = 0;

            protected:
                Sample_Dock_GetResult_Response_DataReaderView () {};
                ~Sample_Dock_GetResult_Response_DataReaderView () {};
            private:
                Sample_Dock_GetResult_Response_DataReaderView (const Sample_Dock_GetResult_Response_DataReaderView &);
                Sample_Dock_GetResult_Response_DataReaderView & operator = (const Sample_Dock_GetResult_Response_DataReaderView &);
            };
            class Dock_Feedback_TypeSupportInterface;

            typedef Dock_Feedback_TypeSupportInterface * Dock_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_TypeSupportInterface> Dock_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_TypeSupportInterface> Dock_Feedback_TypeSupportInterface_out;


            class Dock_Feedback_DataWriter;

            typedef Dock_Feedback_DataWriter * Dock_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_DataWriter> Dock_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_DataWriter> Dock_Feedback_DataWriter_out;


            class Dock_Feedback_DataReader;

            typedef Dock_Feedback_DataReader * Dock_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_DataReader> Dock_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_DataReader> Dock_Feedback_DataReader_out;


            class Dock_Feedback_DataReaderView;

            typedef Dock_Feedback_DataReaderView * Dock_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_DataReaderView> Dock_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_DataReaderView> Dock_Feedback_DataReaderView_out;

            struct Dock_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dock_Feedback_, struct Dock_Feedback_Seq_uniq_> Dock_Feedback_Seq;
            typedef DDS_DCPSSequence_var < Dock_Feedback_Seq> Dock_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_Feedback_Seq> Dock_Feedback_Seq_out;

            class  Dock_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_Feedback_TypeSupportInterface_var _var_type;

                static Dock_Feedback_TypeSupportInterface_ptr _duplicate (Dock_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_Feedback_TypeSupportInterface () {};
                ~Dock_Feedback_TypeSupportInterface () {};
            private:
                Dock_Feedback_TypeSupportInterface (const Dock_Feedback_TypeSupportInterface &);
                Dock_Feedback_TypeSupportInterface & operator = (const Dock_Feedback_TypeSupportInterface &);
            };

            class  Dock_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_Feedback_DataWriter_ptr _ptr_type;
                typedef Dock_Feedback_DataWriter_var _var_type;

                static Dock_Feedback_DataWriter_ptr _duplicate (Dock_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Feedback_& instance_data) = 0;

            protected:
                Dock_Feedback_DataWriter () {};
                ~Dock_Feedback_DataWriter () {};
            private:
                Dock_Feedback_DataWriter (const Dock_Feedback_DataWriter &);
                Dock_Feedback_DataWriter & operator = (const Dock_Feedback_DataWriter &);
            };

            class  Dock_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_Feedback_DataReader_ptr _ptr_type;
                typedef Dock_Feedback_DataReader_var _var_type;

                static Dock_Feedback_DataReader_ptr _duplicate (Dock_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Feedback_& instance) = 0;

            protected:
                Dock_Feedback_DataReader () {};
                ~Dock_Feedback_DataReader () {};
            private:
                Dock_Feedback_DataReader (const Dock_Feedback_DataReader &);
                Dock_Feedback_DataReader & operator = (const Dock_Feedback_DataReader &);
            };

            class  Dock_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_Feedback_DataReaderView_ptr _ptr_type;
                typedef Dock_Feedback_DataReaderView_var _var_type;

                static Dock_Feedback_DataReaderView_ptr _duplicate (Dock_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Feedback_& instance) = 0;

            protected:
                Dock_Feedback_DataReaderView () {};
                ~Dock_Feedback_DataReaderView () {};
            private:
                Dock_Feedback_DataReaderView (const Dock_Feedback_DataReaderView &);
                Dock_Feedback_DataReaderView & operator = (const Dock_Feedback_DataReaderView &);
            };
            class Dock_FeedbackMessage_TypeSupportInterface;

            typedef Dock_FeedbackMessage_TypeSupportInterface * Dock_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_FeedbackMessage_TypeSupportInterface> Dock_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_FeedbackMessage_TypeSupportInterface> Dock_FeedbackMessage_TypeSupportInterface_out;


            class Dock_FeedbackMessage_DataWriter;

            typedef Dock_FeedbackMessage_DataWriter * Dock_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_FeedbackMessage_DataWriter> Dock_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_FeedbackMessage_DataWriter> Dock_FeedbackMessage_DataWriter_out;


            class Dock_FeedbackMessage_DataReader;

            typedef Dock_FeedbackMessage_DataReader * Dock_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_FeedbackMessage_DataReader> Dock_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_FeedbackMessage_DataReader> Dock_FeedbackMessage_DataReader_out;


            class Dock_FeedbackMessage_DataReaderView;

            typedef Dock_FeedbackMessage_DataReaderView * Dock_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_FeedbackMessage_DataReaderView> Dock_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_FeedbackMessage_DataReaderView> Dock_FeedbackMessage_DataReaderView_out;

            struct Dock_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dock_FeedbackMessage_, struct Dock_FeedbackMessage_Seq_uniq_> Dock_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < Dock_FeedbackMessage_Seq> Dock_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_FeedbackMessage_Seq> Dock_FeedbackMessage_Seq_out;

            class  Dock_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_FeedbackMessage_TypeSupportInterface_var _var_type;

                static Dock_FeedbackMessage_TypeSupportInterface_ptr _duplicate (Dock_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_FeedbackMessage_TypeSupportInterface () {};
                ~Dock_FeedbackMessage_TypeSupportInterface () {};
            private:
                Dock_FeedbackMessage_TypeSupportInterface (const Dock_FeedbackMessage_TypeSupportInterface &);
                Dock_FeedbackMessage_TypeSupportInterface & operator = (const Dock_FeedbackMessage_TypeSupportInterface &);
            };

            class  Dock_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef Dock_FeedbackMessage_DataWriter_var _var_type;

                static Dock_FeedbackMessage_DataWriter_ptr _duplicate (Dock_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_FeedbackMessage_& instance_data) = 0;

            protected:
                Dock_FeedbackMessage_DataWriter () {};
                ~Dock_FeedbackMessage_DataWriter () {};
            private:
                Dock_FeedbackMessage_DataWriter (const Dock_FeedbackMessage_DataWriter &);
                Dock_FeedbackMessage_DataWriter & operator = (const Dock_FeedbackMessage_DataWriter &);
            };

            class  Dock_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef Dock_FeedbackMessage_DataReader_var _var_type;

                static Dock_FeedbackMessage_DataReader_ptr _duplicate (Dock_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_FeedbackMessage_& instance) = 0;

            protected:
                Dock_FeedbackMessage_DataReader () {};
                ~Dock_FeedbackMessage_DataReader () {};
            private:
                Dock_FeedbackMessage_DataReader (const Dock_FeedbackMessage_DataReader &);
                Dock_FeedbackMessage_DataReader & operator = (const Dock_FeedbackMessage_DataReader &);
            };

            class  Dock_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef Dock_FeedbackMessage_DataReaderView_var _var_type;

                static Dock_FeedbackMessage_DataReaderView_ptr _duplicate (Dock_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_FeedbackMessage_& instance) = 0;

            protected:
                Dock_FeedbackMessage_DataReaderView () {};
                ~Dock_FeedbackMessage_DataReaderView () {};
            private:
                Dock_FeedbackMessage_DataReaderView (const Dock_FeedbackMessage_DataReaderView &);
                Dock_FeedbackMessage_DataReaderView & operator = (const Dock_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
