#ifndef _H_5F98C18CFBED07723E4E24EC4DEFDDD2_Rotate_DCPS_H_
#define _H_5F98C18CFBED07723E4E24EC4DEFDDD2_Rotate_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Rotate_.h"


namespace py_trees_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            class Rotate_Goal_TypeSupportInterface;

            typedef Rotate_Goal_TypeSupportInterface * Rotate_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Goal_TypeSupportInterface> Rotate_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_Goal_TypeSupportInterface> Rotate_Goal_TypeSupportInterface_out;


            class Rotate_Goal_DataWriter;

            typedef Rotate_Goal_DataWriter * Rotate_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Goal_DataWriter> Rotate_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_Goal_DataWriter> Rotate_Goal_DataWriter_out;


            class Rotate_Goal_DataReader;

            typedef Rotate_Goal_DataReader * Rotate_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Goal_DataReader> Rotate_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_Goal_DataReader> Rotate_Goal_DataReader_out;


            class Rotate_Goal_DataReaderView;

            typedef Rotate_Goal_DataReaderView * Rotate_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Goal_DataReaderView> Rotate_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_Goal_DataReaderView> Rotate_Goal_DataReaderView_out;

            struct Rotate_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rotate_Goal_, struct Rotate_Goal_Seq_uniq_> Rotate_Goal_Seq;
            typedef DDS_DCPSSequence_var < Rotate_Goal_Seq> Rotate_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_Goal_Seq> Rotate_Goal_Seq_out;

            class  Rotate_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_Goal_TypeSupportInterface_var _var_type;

                static Rotate_Goal_TypeSupportInterface_ptr _duplicate (Rotate_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_Goal_TypeSupportInterface () {};
                ~Rotate_Goal_TypeSupportInterface () {};
            private:
                Rotate_Goal_TypeSupportInterface (const Rotate_Goal_TypeSupportInterface &);
                Rotate_Goal_TypeSupportInterface & operator = (const Rotate_Goal_TypeSupportInterface &);
            };

            class  Rotate_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_Goal_DataWriter_ptr _ptr_type;
                typedef Rotate_Goal_DataWriter_var _var_type;

                static Rotate_Goal_DataWriter_ptr _duplicate (Rotate_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Goal_& instance_data) = 0;

            protected:
                Rotate_Goal_DataWriter () {};
                ~Rotate_Goal_DataWriter () {};
            private:
                Rotate_Goal_DataWriter (const Rotate_Goal_DataWriter &);
                Rotate_Goal_DataWriter & operator = (const Rotate_Goal_DataWriter &);
            };

            class  Rotate_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_Goal_DataReader_ptr _ptr_type;
                typedef Rotate_Goal_DataReader_var _var_type;

                static Rotate_Goal_DataReader_ptr _duplicate (Rotate_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Goal_& instance) = 0;

            protected:
                Rotate_Goal_DataReader () {};
                ~Rotate_Goal_DataReader () {};
            private:
                Rotate_Goal_DataReader (const Rotate_Goal_DataReader &);
                Rotate_Goal_DataReader & operator = (const Rotate_Goal_DataReader &);
            };

            class  Rotate_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_Goal_DataReaderView_ptr _ptr_type;
                typedef Rotate_Goal_DataReaderView_var _var_type;

                static Rotate_Goal_DataReaderView_ptr _duplicate (Rotate_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Goal_& instance) = 0;

            protected:
                Rotate_Goal_DataReaderView () {};
                ~Rotate_Goal_DataReaderView () {};
            private:
                Rotate_Goal_DataReaderView (const Rotate_Goal_DataReaderView &);
                Rotate_Goal_DataReaderView & operator = (const Rotate_Goal_DataReaderView &);
            };
            class Rotate_SendGoal_Request_TypeSupportInterface;

            typedef Rotate_SendGoal_Request_TypeSupportInterface * Rotate_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Request_TypeSupportInterface> Rotate_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Request_TypeSupportInterface> Rotate_SendGoal_Request_TypeSupportInterface_out;


            class Rotate_SendGoal_Request_DataWriter;

            typedef Rotate_SendGoal_Request_DataWriter * Rotate_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Request_DataWriter> Rotate_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Request_DataWriter> Rotate_SendGoal_Request_DataWriter_out;


            class Rotate_SendGoal_Request_DataReader;

            typedef Rotate_SendGoal_Request_DataReader * Rotate_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Request_DataReader> Rotate_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Request_DataReader> Rotate_SendGoal_Request_DataReader_out;


            class Rotate_SendGoal_Request_DataReaderView;

            typedef Rotate_SendGoal_Request_DataReaderView * Rotate_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Request_DataReaderView> Rotate_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Request_DataReaderView> Rotate_SendGoal_Request_DataReaderView_out;

            struct Rotate_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rotate_SendGoal_Request_, struct Rotate_SendGoal_Request_Seq_uniq_> Rotate_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Rotate_SendGoal_Request_Seq> Rotate_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_SendGoal_Request_Seq> Rotate_SendGoal_Request_Seq_out;

            class  Rotate_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Rotate_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Rotate_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_SendGoal_Request_TypeSupportInterface () {};
                ~Rotate_SendGoal_Request_TypeSupportInterface () {};
            private:
                Rotate_SendGoal_Request_TypeSupportInterface (const Rotate_SendGoal_Request_TypeSupportInterface &);
                Rotate_SendGoal_Request_TypeSupportInterface & operator = (const Rotate_SendGoal_Request_TypeSupportInterface &);
            };

            class  Rotate_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Rotate_SendGoal_Request_DataWriter_var _var_type;

                static Rotate_SendGoal_Request_DataWriter_ptr _duplicate (Rotate_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_SendGoal_Request_& instance_data) = 0;

            protected:
                Rotate_SendGoal_Request_DataWriter () {};
                ~Rotate_SendGoal_Request_DataWriter () {};
            private:
                Rotate_SendGoal_Request_DataWriter (const Rotate_SendGoal_Request_DataWriter &);
                Rotate_SendGoal_Request_DataWriter & operator = (const Rotate_SendGoal_Request_DataWriter &);
            };

            class  Rotate_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Rotate_SendGoal_Request_DataReader_var _var_type;

                static Rotate_SendGoal_Request_DataReader_ptr _duplicate (Rotate_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_SendGoal_Request_& instance) = 0;

            protected:
                Rotate_SendGoal_Request_DataReader () {};
                ~Rotate_SendGoal_Request_DataReader () {};
            private:
                Rotate_SendGoal_Request_DataReader (const Rotate_SendGoal_Request_DataReader &);
                Rotate_SendGoal_Request_DataReader & operator = (const Rotate_SendGoal_Request_DataReader &);
            };

            class  Rotate_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Rotate_SendGoal_Request_DataReaderView_var _var_type;

                static Rotate_SendGoal_Request_DataReaderView_ptr _duplicate (Rotate_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_SendGoal_Request_& instance) = 0;

            protected:
                Rotate_SendGoal_Request_DataReaderView () {};
                ~Rotate_SendGoal_Request_DataReaderView () {};
            private:
                Rotate_SendGoal_Request_DataReaderView (const Rotate_SendGoal_Request_DataReaderView &);
                Rotate_SendGoal_Request_DataReaderView & operator = (const Rotate_SendGoal_Request_DataReaderView &);
            };
            class Rotate_SendGoal_Response_TypeSupportInterface;

            typedef Rotate_SendGoal_Response_TypeSupportInterface * Rotate_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Response_TypeSupportInterface> Rotate_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Response_TypeSupportInterface> Rotate_SendGoal_Response_TypeSupportInterface_out;


            class Rotate_SendGoal_Response_DataWriter;

            typedef Rotate_SendGoal_Response_DataWriter * Rotate_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Response_DataWriter> Rotate_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Response_DataWriter> Rotate_SendGoal_Response_DataWriter_out;


            class Rotate_SendGoal_Response_DataReader;

            typedef Rotate_SendGoal_Response_DataReader * Rotate_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Response_DataReader> Rotate_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Response_DataReader> Rotate_SendGoal_Response_DataReader_out;


            class Rotate_SendGoal_Response_DataReaderView;

            typedef Rotate_SendGoal_Response_DataReaderView * Rotate_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_SendGoal_Response_DataReaderView> Rotate_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_SendGoal_Response_DataReaderView> Rotate_SendGoal_Response_DataReaderView_out;

            struct Rotate_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rotate_SendGoal_Response_, struct Rotate_SendGoal_Response_Seq_uniq_> Rotate_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Rotate_SendGoal_Response_Seq> Rotate_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_SendGoal_Response_Seq> Rotate_SendGoal_Response_Seq_out;

            class  Rotate_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Rotate_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Rotate_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_SendGoal_Response_TypeSupportInterface () {};
                ~Rotate_SendGoal_Response_TypeSupportInterface () {};
            private:
                Rotate_SendGoal_Response_TypeSupportInterface (const Rotate_SendGoal_Response_TypeSupportInterface &);
                Rotate_SendGoal_Response_TypeSupportInterface & operator = (const Rotate_SendGoal_Response_TypeSupportInterface &);
            };

            class  Rotate_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Rotate_SendGoal_Response_DataWriter_var _var_type;

                static Rotate_SendGoal_Response_DataWriter_ptr _duplicate (Rotate_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_SendGoal_Response_& instance_data) = 0;

            protected:
                Rotate_SendGoal_Response_DataWriter () {};
                ~Rotate_SendGoal_Response_DataWriter () {};
            private:
                Rotate_SendGoal_Response_DataWriter (const Rotate_SendGoal_Response_DataWriter &);
                Rotate_SendGoal_Response_DataWriter & operator = (const Rotate_SendGoal_Response_DataWriter &);
            };

            class  Rotate_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Rotate_SendGoal_Response_DataReader_var _var_type;

                static Rotate_SendGoal_Response_DataReader_ptr _duplicate (Rotate_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_SendGoal_Response_& instance) = 0;

            protected:
                Rotate_SendGoal_Response_DataReader () {};
                ~Rotate_SendGoal_Response_DataReader () {};
            private:
                Rotate_SendGoal_Response_DataReader (const Rotate_SendGoal_Response_DataReader &);
                Rotate_SendGoal_Response_DataReader & operator = (const Rotate_SendGoal_Response_DataReader &);
            };

            class  Rotate_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Rotate_SendGoal_Response_DataReaderView_var _var_type;

                static Rotate_SendGoal_Response_DataReaderView_ptr _duplicate (Rotate_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_SendGoal_Response_& instance) = 0;

            protected:
                Rotate_SendGoal_Response_DataReaderView () {};
                ~Rotate_SendGoal_Response_DataReaderView () {};
            private:
                Rotate_SendGoal_Response_DataReaderView (const Rotate_SendGoal_Response_DataReaderView &);
                Rotate_SendGoal_Response_DataReaderView & operator = (const Rotate_SendGoal_Response_DataReaderView &);
            };
            class Sample_Rotate_SendGoal_Request_TypeSupportInterface;

            typedef Sample_Rotate_SendGoal_Request_TypeSupportInterface * Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Request_TypeSupportInterface> Sample_Rotate_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Request_TypeSupportInterface> Sample_Rotate_SendGoal_Request_TypeSupportInterface_out;


            class Sample_Rotate_SendGoal_Request_DataWriter;

            typedef Sample_Rotate_SendGoal_Request_DataWriter * Sample_Rotate_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Request_DataWriter> Sample_Rotate_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Request_DataWriter> Sample_Rotate_SendGoal_Request_DataWriter_out;


            class Sample_Rotate_SendGoal_Request_DataReader;

            typedef Sample_Rotate_SendGoal_Request_DataReader * Sample_Rotate_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Request_DataReader> Sample_Rotate_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Request_DataReader> Sample_Rotate_SendGoal_Request_DataReader_out;


            class Sample_Rotate_SendGoal_Request_DataReaderView;

            typedef Sample_Rotate_SendGoal_Request_DataReaderView * Sample_Rotate_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Request_DataReaderView> Sample_Rotate_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Request_DataReaderView> Sample_Rotate_SendGoal_Request_DataReaderView_out;

            struct Sample_Rotate_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Rotate_SendGoal_Request_, struct Sample_Rotate_SendGoal_Request_Seq_uniq_> Sample_Rotate_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Rotate_SendGoal_Request_Seq> Sample_Rotate_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Rotate_SendGoal_Request_Seq> Sample_Rotate_SendGoal_Request_Seq_out;

            class  Sample_Rotate_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Rotate_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_Rotate_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_Rotate_SendGoal_Request_TypeSupportInterface (const Sample_Rotate_SendGoal_Request_TypeSupportInterface &);
                Sample_Rotate_SendGoal_Request_TypeSupportInterface & operator = (const Sample_Rotate_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_Rotate_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Rotate_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Request_DataWriter_var _var_type;

                static Sample_Rotate_SendGoal_Request_DataWriter_ptr _duplicate (Sample_Rotate_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Rotate_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Rotate_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Rotate_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_Rotate_SendGoal_Request_DataWriter () {};
                ~Sample_Rotate_SendGoal_Request_DataWriter () {};
            private:
                Sample_Rotate_SendGoal_Request_DataWriter (const Sample_Rotate_SendGoal_Request_DataWriter &);
                Sample_Rotate_SendGoal_Request_DataWriter & operator = (const Sample_Rotate_SendGoal_Request_DataWriter &);
            };

            class  Sample_Rotate_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Rotate_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Request_DataReader_var _var_type;

                static Sample_Rotate_SendGoal_Request_DataReader_ptr _duplicate (Sample_Rotate_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Rotate_SendGoal_Request_DataReader () {};
                ~Sample_Rotate_SendGoal_Request_DataReader () {};
            private:
                Sample_Rotate_SendGoal_Request_DataReader (const Sample_Rotate_SendGoal_Request_DataReader &);
                Sample_Rotate_SendGoal_Request_DataReader & operator = (const Sample_Rotate_SendGoal_Request_DataReader &);
            };

            class  Sample_Rotate_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Rotate_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_Rotate_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_Rotate_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Rotate_SendGoal_Request_DataReaderView () {};
                ~Sample_Rotate_SendGoal_Request_DataReaderView () {};
            private:
                Sample_Rotate_SendGoal_Request_DataReaderView (const Sample_Rotate_SendGoal_Request_DataReaderView &);
                Sample_Rotate_SendGoal_Request_DataReaderView & operator = (const Sample_Rotate_SendGoal_Request_DataReaderView &);
            };
            class Sample_Rotate_SendGoal_Response_TypeSupportInterface;

            typedef Sample_Rotate_SendGoal_Response_TypeSupportInterface * Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Response_TypeSupportInterface> Sample_Rotate_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Response_TypeSupportInterface> Sample_Rotate_SendGoal_Response_TypeSupportInterface_out;


            class Sample_Rotate_SendGoal_Response_DataWriter;

            typedef Sample_Rotate_SendGoal_Response_DataWriter * Sample_Rotate_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Response_DataWriter> Sample_Rotate_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Response_DataWriter> Sample_Rotate_SendGoal_Response_DataWriter_out;


            class Sample_Rotate_SendGoal_Response_DataReader;

            typedef Sample_Rotate_SendGoal_Response_DataReader * Sample_Rotate_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Response_DataReader> Sample_Rotate_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Response_DataReader> Sample_Rotate_SendGoal_Response_DataReader_out;


            class Sample_Rotate_SendGoal_Response_DataReaderView;

            typedef Sample_Rotate_SendGoal_Response_DataReaderView * Sample_Rotate_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_SendGoal_Response_DataReaderView> Sample_Rotate_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_SendGoal_Response_DataReaderView> Sample_Rotate_SendGoal_Response_DataReaderView_out;

            struct Sample_Rotate_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Rotate_SendGoal_Response_, struct Sample_Rotate_SendGoal_Response_Seq_uniq_> Sample_Rotate_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Rotate_SendGoal_Response_Seq> Sample_Rotate_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Rotate_SendGoal_Response_Seq> Sample_Rotate_SendGoal_Response_Seq_out;

            class  Sample_Rotate_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Rotate_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_Rotate_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_Rotate_SendGoal_Response_TypeSupportInterface (const Sample_Rotate_SendGoal_Response_TypeSupportInterface &);
                Sample_Rotate_SendGoal_Response_TypeSupportInterface & operator = (const Sample_Rotate_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_Rotate_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Rotate_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Response_DataWriter_var _var_type;

                static Sample_Rotate_SendGoal_Response_DataWriter_ptr _duplicate (Sample_Rotate_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Rotate_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Rotate_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Rotate_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_Rotate_SendGoal_Response_DataWriter () {};
                ~Sample_Rotate_SendGoal_Response_DataWriter () {};
            private:
                Sample_Rotate_SendGoal_Response_DataWriter (const Sample_Rotate_SendGoal_Response_DataWriter &);
                Sample_Rotate_SendGoal_Response_DataWriter & operator = (const Sample_Rotate_SendGoal_Response_DataWriter &);
            };

            class  Sample_Rotate_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Rotate_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Response_DataReader_var _var_type;

                static Sample_Rotate_SendGoal_Response_DataReader_ptr _duplicate (Sample_Rotate_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Rotate_SendGoal_Response_DataReader () {};
                ~Sample_Rotate_SendGoal_Response_DataReader () {};
            private:
                Sample_Rotate_SendGoal_Response_DataReader (const Sample_Rotate_SendGoal_Response_DataReader &);
                Sample_Rotate_SendGoal_Response_DataReader & operator = (const Sample_Rotate_SendGoal_Response_DataReader &);
            };

            class  Sample_Rotate_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Rotate_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Rotate_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_Rotate_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_Rotate_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Rotate_SendGoal_Response_DataReaderView () {};
                ~Sample_Rotate_SendGoal_Response_DataReaderView () {};
            private:
                Sample_Rotate_SendGoal_Response_DataReaderView (const Sample_Rotate_SendGoal_Response_DataReaderView &);
                Sample_Rotate_SendGoal_Response_DataReaderView & operator = (const Sample_Rotate_SendGoal_Response_DataReaderView &);
            };
            class Rotate_Result_TypeSupportInterface;

            typedef Rotate_Result_TypeSupportInterface * Rotate_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Result_TypeSupportInterface> Rotate_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_Result_TypeSupportInterface> Rotate_Result_TypeSupportInterface_out;


            class Rotate_Result_DataWriter;

            typedef Rotate_Result_DataWriter * Rotate_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Result_DataWriter> Rotate_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_Result_DataWriter> Rotate_Result_DataWriter_out;


            class Rotate_Result_DataReader;

            typedef Rotate_Result_DataReader * Rotate_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Result_DataReader> Rotate_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_Result_DataReader> Rotate_Result_DataReader_out;


            class Rotate_Result_DataReaderView;

            typedef Rotate_Result_DataReaderView * Rotate_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Result_DataReaderView> Rotate_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_Result_DataReaderView> Rotate_Result_DataReaderView_out;

            struct Rotate_Result_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Rotate_Result_, struct Rotate_Result_Seq_uniq_> Rotate_Result_Seq;
            typedef DDS_DCPSSequence_var < Rotate_Result_Seq> Rotate_Result_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_Result_Seq> Rotate_Result_Seq_out;

            class  Rotate_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_Result_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_Result_TypeSupportInterface_var _var_type;

                static Rotate_Result_TypeSupportInterface_ptr _duplicate (Rotate_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_Result_TypeSupportInterface () {};
                ~Rotate_Result_TypeSupportInterface () {};
            private:
                Rotate_Result_TypeSupportInterface (const Rotate_Result_TypeSupportInterface &);
                Rotate_Result_TypeSupportInterface & operator = (const Rotate_Result_TypeSupportInterface &);
            };

            class  Rotate_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_Result_DataWriter_ptr _ptr_type;
                typedef Rotate_Result_DataWriter_var _var_type;

                static Rotate_Result_DataWriter_ptr _duplicate (Rotate_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Result_& instance_data) = 0;

            protected:
                Rotate_Result_DataWriter () {};
                ~Rotate_Result_DataWriter () {};
            private:
                Rotate_Result_DataWriter (const Rotate_Result_DataWriter &);
                Rotate_Result_DataWriter & operator = (const Rotate_Result_DataWriter &);
            };

            class  Rotate_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_Result_DataReader_ptr _ptr_type;
                typedef Rotate_Result_DataReader_var _var_type;

                static Rotate_Result_DataReader_ptr _duplicate (Rotate_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Result_& instance) = 0;

            protected:
                Rotate_Result_DataReader () {};
                ~Rotate_Result_DataReader () {};
            private:
                Rotate_Result_DataReader (const Rotate_Result_DataReader &);
                Rotate_Result_DataReader & operator = (const Rotate_Result_DataReader &);
            };

            class  Rotate_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_Result_DataReaderView_ptr _ptr_type;
                typedef Rotate_Result_DataReaderView_var _var_type;

                static Rotate_Result_DataReaderView_ptr _duplicate (Rotate_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Result_& instance) = 0;

            protected:
                Rotate_Result_DataReaderView () {};
                ~Rotate_Result_DataReaderView () {};
            private:
                Rotate_Result_DataReaderView (const Rotate_Result_DataReaderView &);
                Rotate_Result_DataReaderView & operator = (const Rotate_Result_DataReaderView &);
            };
            class Rotate_GetResult_Request_TypeSupportInterface;

            typedef Rotate_GetResult_Request_TypeSupportInterface * Rotate_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Request_TypeSupportInterface> Rotate_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Request_TypeSupportInterface> Rotate_GetResult_Request_TypeSupportInterface_out;


            class Rotate_GetResult_Request_DataWriter;

            typedef Rotate_GetResult_Request_DataWriter * Rotate_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Request_DataWriter> Rotate_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Request_DataWriter> Rotate_GetResult_Request_DataWriter_out;


            class Rotate_GetResult_Request_DataReader;

            typedef Rotate_GetResult_Request_DataReader * Rotate_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Request_DataReader> Rotate_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Request_DataReader> Rotate_GetResult_Request_DataReader_out;


            class Rotate_GetResult_Request_DataReaderView;

            typedef Rotate_GetResult_Request_DataReaderView * Rotate_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Request_DataReaderView> Rotate_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Request_DataReaderView> Rotate_GetResult_Request_DataReaderView_out;

            struct Rotate_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rotate_GetResult_Request_, struct Rotate_GetResult_Request_Seq_uniq_> Rotate_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Rotate_GetResult_Request_Seq> Rotate_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_GetResult_Request_Seq> Rotate_GetResult_Request_Seq_out;

            class  Rotate_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_GetResult_Request_TypeSupportInterface_var _var_type;

                static Rotate_GetResult_Request_TypeSupportInterface_ptr _duplicate (Rotate_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_GetResult_Request_TypeSupportInterface () {};
                ~Rotate_GetResult_Request_TypeSupportInterface () {};
            private:
                Rotate_GetResult_Request_TypeSupportInterface (const Rotate_GetResult_Request_TypeSupportInterface &);
                Rotate_GetResult_Request_TypeSupportInterface & operator = (const Rotate_GetResult_Request_TypeSupportInterface &);
            };

            class  Rotate_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Rotate_GetResult_Request_DataWriter_var _var_type;

                static Rotate_GetResult_Request_DataWriter_ptr _duplicate (Rotate_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_GetResult_Request_& instance_data) = 0;

            protected:
                Rotate_GetResult_Request_DataWriter () {};
                ~Rotate_GetResult_Request_DataWriter () {};
            private:
                Rotate_GetResult_Request_DataWriter (const Rotate_GetResult_Request_DataWriter &);
                Rotate_GetResult_Request_DataWriter & operator = (const Rotate_GetResult_Request_DataWriter &);
            };

            class  Rotate_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Rotate_GetResult_Request_DataReader_var _var_type;

                static Rotate_GetResult_Request_DataReader_ptr _duplicate (Rotate_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_GetResult_Request_& instance) = 0;

            protected:
                Rotate_GetResult_Request_DataReader () {};
                ~Rotate_GetResult_Request_DataReader () {};
            private:
                Rotate_GetResult_Request_DataReader (const Rotate_GetResult_Request_DataReader &);
                Rotate_GetResult_Request_DataReader & operator = (const Rotate_GetResult_Request_DataReader &);
            };

            class  Rotate_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Rotate_GetResult_Request_DataReaderView_var _var_type;

                static Rotate_GetResult_Request_DataReaderView_ptr _duplicate (Rotate_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_GetResult_Request_& instance) = 0;

            protected:
                Rotate_GetResult_Request_DataReaderView () {};
                ~Rotate_GetResult_Request_DataReaderView () {};
            private:
                Rotate_GetResult_Request_DataReaderView (const Rotate_GetResult_Request_DataReaderView &);
                Rotate_GetResult_Request_DataReaderView & operator = (const Rotate_GetResult_Request_DataReaderView &);
            };
            class Rotate_GetResult_Response_TypeSupportInterface;

            typedef Rotate_GetResult_Response_TypeSupportInterface * Rotate_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Response_TypeSupportInterface> Rotate_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Response_TypeSupportInterface> Rotate_GetResult_Response_TypeSupportInterface_out;


            class Rotate_GetResult_Response_DataWriter;

            typedef Rotate_GetResult_Response_DataWriter * Rotate_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Response_DataWriter> Rotate_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Response_DataWriter> Rotate_GetResult_Response_DataWriter_out;


            class Rotate_GetResult_Response_DataReader;

            typedef Rotate_GetResult_Response_DataReader * Rotate_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Response_DataReader> Rotate_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Response_DataReader> Rotate_GetResult_Response_DataReader_out;


            class Rotate_GetResult_Response_DataReaderView;

            typedef Rotate_GetResult_Response_DataReaderView * Rotate_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_GetResult_Response_DataReaderView> Rotate_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_GetResult_Response_DataReaderView> Rotate_GetResult_Response_DataReaderView_out;

            struct Rotate_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Rotate_GetResult_Response_, struct Rotate_GetResult_Response_Seq_uniq_> Rotate_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Rotate_GetResult_Response_Seq> Rotate_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_GetResult_Response_Seq> Rotate_GetResult_Response_Seq_out;

            class  Rotate_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_GetResult_Response_TypeSupportInterface_var _var_type;

                static Rotate_GetResult_Response_TypeSupportInterface_ptr _duplicate (Rotate_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_GetResult_Response_TypeSupportInterface () {};
                ~Rotate_GetResult_Response_TypeSupportInterface () {};
            private:
                Rotate_GetResult_Response_TypeSupportInterface (const Rotate_GetResult_Response_TypeSupportInterface &);
                Rotate_GetResult_Response_TypeSupportInterface & operator = (const Rotate_GetResult_Response_TypeSupportInterface &);
            };

            class  Rotate_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Rotate_GetResult_Response_DataWriter_var _var_type;

                static Rotate_GetResult_Response_DataWriter_ptr _duplicate (Rotate_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_GetResult_Response_& instance_data) = 0;

            protected:
                Rotate_GetResult_Response_DataWriter () {};
                ~Rotate_GetResult_Response_DataWriter () {};
            private:
                Rotate_GetResult_Response_DataWriter (const Rotate_GetResult_Response_DataWriter &);
                Rotate_GetResult_Response_DataWriter & operator = (const Rotate_GetResult_Response_DataWriter &);
            };

            class  Rotate_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Rotate_GetResult_Response_DataReader_var _var_type;

                static Rotate_GetResult_Response_DataReader_ptr _duplicate (Rotate_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_GetResult_Response_& instance) = 0;

            protected:
                Rotate_GetResult_Response_DataReader () {};
                ~Rotate_GetResult_Response_DataReader () {};
            private:
                Rotate_GetResult_Response_DataReader (const Rotate_GetResult_Response_DataReader &);
                Rotate_GetResult_Response_DataReader & operator = (const Rotate_GetResult_Response_DataReader &);
            };

            class  Rotate_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Rotate_GetResult_Response_DataReaderView_var _var_type;

                static Rotate_GetResult_Response_DataReaderView_ptr _duplicate (Rotate_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_GetResult_Response_& instance) = 0;

            protected:
                Rotate_GetResult_Response_DataReaderView () {};
                ~Rotate_GetResult_Response_DataReaderView () {};
            private:
                Rotate_GetResult_Response_DataReaderView (const Rotate_GetResult_Response_DataReaderView &);
                Rotate_GetResult_Response_DataReaderView & operator = (const Rotate_GetResult_Response_DataReaderView &);
            };
            class Sample_Rotate_GetResult_Request_TypeSupportInterface;

            typedef Sample_Rotate_GetResult_Request_TypeSupportInterface * Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Request_TypeSupportInterface> Sample_Rotate_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Request_TypeSupportInterface> Sample_Rotate_GetResult_Request_TypeSupportInterface_out;


            class Sample_Rotate_GetResult_Request_DataWriter;

            typedef Sample_Rotate_GetResult_Request_DataWriter * Sample_Rotate_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Request_DataWriter> Sample_Rotate_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Request_DataWriter> Sample_Rotate_GetResult_Request_DataWriter_out;


            class Sample_Rotate_GetResult_Request_DataReader;

            typedef Sample_Rotate_GetResult_Request_DataReader * Sample_Rotate_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Request_DataReader> Sample_Rotate_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Request_DataReader> Sample_Rotate_GetResult_Request_DataReader_out;


            class Sample_Rotate_GetResult_Request_DataReaderView;

            typedef Sample_Rotate_GetResult_Request_DataReaderView * Sample_Rotate_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Request_DataReaderView> Sample_Rotate_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Request_DataReaderView> Sample_Rotate_GetResult_Request_DataReaderView_out;

            struct Sample_Rotate_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Rotate_GetResult_Request_, struct Sample_Rotate_GetResult_Request_Seq_uniq_> Sample_Rotate_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Rotate_GetResult_Request_Seq> Sample_Rotate_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Rotate_GetResult_Request_Seq> Sample_Rotate_GetResult_Request_Seq_out;

            class  Sample_Rotate_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Rotate_GetResult_Request_TypeSupportInterface () {};
                ~Sample_Rotate_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_Rotate_GetResult_Request_TypeSupportInterface (const Sample_Rotate_GetResult_Request_TypeSupportInterface &);
                Sample_Rotate_GetResult_Request_TypeSupportInterface & operator = (const Sample_Rotate_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_Rotate_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Rotate_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Request_DataWriter_var _var_type;

                static Sample_Rotate_GetResult_Request_DataWriter_ptr _duplicate (Sample_Rotate_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Rotate_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Rotate_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Rotate_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_Rotate_GetResult_Request_DataWriter () {};
                ~Sample_Rotate_GetResult_Request_DataWriter () {};
            private:
                Sample_Rotate_GetResult_Request_DataWriter (const Sample_Rotate_GetResult_Request_DataWriter &);
                Sample_Rotate_GetResult_Request_DataWriter & operator = (const Sample_Rotate_GetResult_Request_DataWriter &);
            };

            class  Sample_Rotate_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Rotate_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Request_DataReader_var _var_type;

                static Sample_Rotate_GetResult_Request_DataReader_ptr _duplicate (Sample_Rotate_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_GetResult_Request_& instance) = 0;

            protected:
                Sample_Rotate_GetResult_Request_DataReader () {};
                ~Sample_Rotate_GetResult_Request_DataReader () {};
            private:
                Sample_Rotate_GetResult_Request_DataReader (const Sample_Rotate_GetResult_Request_DataReader &);
                Sample_Rotate_GetResult_Request_DataReader & operator = (const Sample_Rotate_GetResult_Request_DataReader &);
            };

            class  Sample_Rotate_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Rotate_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Request_DataReaderView_var _var_type;

                static Sample_Rotate_GetResult_Request_DataReaderView_ptr _duplicate (Sample_Rotate_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_GetResult_Request_& instance) = 0;

            protected:
                Sample_Rotate_GetResult_Request_DataReaderView () {};
                ~Sample_Rotate_GetResult_Request_DataReaderView () {};
            private:
                Sample_Rotate_GetResult_Request_DataReaderView (const Sample_Rotate_GetResult_Request_DataReaderView &);
                Sample_Rotate_GetResult_Request_DataReaderView & operator = (const Sample_Rotate_GetResult_Request_DataReaderView &);
            };
            class Sample_Rotate_GetResult_Response_TypeSupportInterface;

            typedef Sample_Rotate_GetResult_Response_TypeSupportInterface * Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Response_TypeSupportInterface> Sample_Rotate_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Response_TypeSupportInterface> Sample_Rotate_GetResult_Response_TypeSupportInterface_out;


            class Sample_Rotate_GetResult_Response_DataWriter;

            typedef Sample_Rotate_GetResult_Response_DataWriter * Sample_Rotate_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Response_DataWriter> Sample_Rotate_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Response_DataWriter> Sample_Rotate_GetResult_Response_DataWriter_out;


            class Sample_Rotate_GetResult_Response_DataReader;

            typedef Sample_Rotate_GetResult_Response_DataReader * Sample_Rotate_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Response_DataReader> Sample_Rotate_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Response_DataReader> Sample_Rotate_GetResult_Response_DataReader_out;


            class Sample_Rotate_GetResult_Response_DataReaderView;

            typedef Sample_Rotate_GetResult_Response_DataReaderView * Sample_Rotate_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Rotate_GetResult_Response_DataReaderView> Sample_Rotate_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Rotate_GetResult_Response_DataReaderView> Sample_Rotate_GetResult_Response_DataReaderView_out;

            struct Sample_Rotate_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Rotate_GetResult_Response_, struct Sample_Rotate_GetResult_Response_Seq_uniq_> Sample_Rotate_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Rotate_GetResult_Response_Seq> Sample_Rotate_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Rotate_GetResult_Response_Seq> Sample_Rotate_GetResult_Response_Seq_out;

            class  Sample_Rotate_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Rotate_GetResult_Response_TypeSupportInterface () {};
                ~Sample_Rotate_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_Rotate_GetResult_Response_TypeSupportInterface (const Sample_Rotate_GetResult_Response_TypeSupportInterface &);
                Sample_Rotate_GetResult_Response_TypeSupportInterface & operator = (const Sample_Rotate_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_Rotate_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Rotate_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Response_DataWriter_var _var_type;

                static Sample_Rotate_GetResult_Response_DataWriter_ptr _duplicate (Sample_Rotate_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Rotate_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Rotate_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Rotate_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_Rotate_GetResult_Response_DataWriter () {};
                ~Sample_Rotate_GetResult_Response_DataWriter () {};
            private:
                Sample_Rotate_GetResult_Response_DataWriter (const Sample_Rotate_GetResult_Response_DataWriter &);
                Sample_Rotate_GetResult_Response_DataWriter & operator = (const Sample_Rotate_GetResult_Response_DataWriter &);
            };

            class  Sample_Rotate_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Rotate_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Response_DataReader_var _var_type;

                static Sample_Rotate_GetResult_Response_DataReader_ptr _duplicate (Sample_Rotate_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_GetResult_Response_& instance) = 0;

            protected:
                Sample_Rotate_GetResult_Response_DataReader () {};
                ~Sample_Rotate_GetResult_Response_DataReader () {};
            private:
                Sample_Rotate_GetResult_Response_DataReader (const Sample_Rotate_GetResult_Response_DataReader &);
                Sample_Rotate_GetResult_Response_DataReader & operator = (const Sample_Rotate_GetResult_Response_DataReader &);
            };

            class  Sample_Rotate_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Rotate_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Rotate_GetResult_Response_DataReaderView_var _var_type;

                static Sample_Rotate_GetResult_Response_DataReaderView_ptr _duplicate (Sample_Rotate_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Rotate_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Rotate_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Rotate_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Rotate_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Rotate_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Rotate_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Rotate_GetResult_Response_& instance) = 0;

            protected:
                Sample_Rotate_GetResult_Response_DataReaderView () {};
                ~Sample_Rotate_GetResult_Response_DataReaderView () {};
            private:
                Sample_Rotate_GetResult_Response_DataReaderView (const Sample_Rotate_GetResult_Response_DataReaderView &);
                Sample_Rotate_GetResult_Response_DataReaderView & operator = (const Sample_Rotate_GetResult_Response_DataReaderView &);
            };
            class Rotate_Feedback_TypeSupportInterface;

            typedef Rotate_Feedback_TypeSupportInterface * Rotate_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_TypeSupportInterface> Rotate_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_TypeSupportInterface> Rotate_Feedback_TypeSupportInterface_out;


            class Rotate_Feedback_DataWriter;

            typedef Rotate_Feedback_DataWriter * Rotate_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_DataWriter> Rotate_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_DataWriter> Rotate_Feedback_DataWriter_out;


            class Rotate_Feedback_DataReader;

            typedef Rotate_Feedback_DataReader * Rotate_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_DataReader> Rotate_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_DataReader> Rotate_Feedback_DataReader_out;


            class Rotate_Feedback_DataReaderView;

            typedef Rotate_Feedback_DataReaderView * Rotate_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_DataReaderView> Rotate_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_DataReaderView> Rotate_Feedback_DataReaderView_out;

            struct Rotate_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rotate_Feedback_, struct Rotate_Feedback_Seq_uniq_> Rotate_Feedback_Seq;
            typedef DDS_DCPSSequence_var < Rotate_Feedback_Seq> Rotate_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_Feedback_Seq> Rotate_Feedback_Seq_out;

            class  Rotate_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_Feedback_TypeSupportInterface_var _var_type;

                static Rotate_Feedback_TypeSupportInterface_ptr _duplicate (Rotate_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_Feedback_TypeSupportInterface () {};
                ~Rotate_Feedback_TypeSupportInterface () {};
            private:
                Rotate_Feedback_TypeSupportInterface (const Rotate_Feedback_TypeSupportInterface &);
                Rotate_Feedback_TypeSupportInterface & operator = (const Rotate_Feedback_TypeSupportInterface &);
            };

            class  Rotate_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_Feedback_DataWriter_ptr _ptr_type;
                typedef Rotate_Feedback_DataWriter_var _var_type;

                static Rotate_Feedback_DataWriter_ptr _duplicate (Rotate_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Feedback_& instance_data) = 0;

            protected:
                Rotate_Feedback_DataWriter () {};
                ~Rotate_Feedback_DataWriter () {};
            private:
                Rotate_Feedback_DataWriter (const Rotate_Feedback_DataWriter &);
                Rotate_Feedback_DataWriter & operator = (const Rotate_Feedback_DataWriter &);
            };

            class  Rotate_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_Feedback_DataReader_ptr _ptr_type;
                typedef Rotate_Feedback_DataReader_var _var_type;

                static Rotate_Feedback_DataReader_ptr _duplicate (Rotate_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Feedback_& instance) = 0;

            protected:
                Rotate_Feedback_DataReader () {};
                ~Rotate_Feedback_DataReader () {};
            private:
                Rotate_Feedback_DataReader (const Rotate_Feedback_DataReader &);
                Rotate_Feedback_DataReader & operator = (const Rotate_Feedback_DataReader &);
            };

            class  Rotate_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_Feedback_DataReaderView_ptr _ptr_type;
                typedef Rotate_Feedback_DataReaderView_var _var_type;

                static Rotate_Feedback_DataReaderView_ptr _duplicate (Rotate_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Feedback_& instance) = 0;

            protected:
                Rotate_Feedback_DataReaderView () {};
                ~Rotate_Feedback_DataReaderView () {};
            private:
                Rotate_Feedback_DataReaderView (const Rotate_Feedback_DataReaderView &);
                Rotate_Feedback_DataReaderView & operator = (const Rotate_Feedback_DataReaderView &);
            };
            class Rotate_FeedbackMessage_TypeSupportInterface;

            typedef Rotate_FeedbackMessage_TypeSupportInterface * Rotate_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_FeedbackMessage_TypeSupportInterface> Rotate_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_FeedbackMessage_TypeSupportInterface> Rotate_FeedbackMessage_TypeSupportInterface_out;


            class Rotate_FeedbackMessage_DataWriter;

            typedef Rotate_FeedbackMessage_DataWriter * Rotate_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_FeedbackMessage_DataWriter> Rotate_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_FeedbackMessage_DataWriter> Rotate_FeedbackMessage_DataWriter_out;


            class Rotate_FeedbackMessage_DataReader;

            typedef Rotate_FeedbackMessage_DataReader * Rotate_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_FeedbackMessage_DataReader> Rotate_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_FeedbackMessage_DataReader> Rotate_FeedbackMessage_DataReader_out;


            class Rotate_FeedbackMessage_DataReaderView;

            typedef Rotate_FeedbackMessage_DataReaderView * Rotate_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_FeedbackMessage_DataReaderView> Rotate_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_FeedbackMessage_DataReaderView> Rotate_FeedbackMessage_DataReaderView_out;

            struct Rotate_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rotate_FeedbackMessage_, struct Rotate_FeedbackMessage_Seq_uniq_> Rotate_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < Rotate_FeedbackMessage_Seq> Rotate_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_FeedbackMessage_Seq> Rotate_FeedbackMessage_Seq_out;

            class  Rotate_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_FeedbackMessage_TypeSupportInterface_var _var_type;

                static Rotate_FeedbackMessage_TypeSupportInterface_ptr _duplicate (Rotate_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_FeedbackMessage_TypeSupportInterface () {};
                ~Rotate_FeedbackMessage_TypeSupportInterface () {};
            private:
                Rotate_FeedbackMessage_TypeSupportInterface (const Rotate_FeedbackMessage_TypeSupportInterface &);
                Rotate_FeedbackMessage_TypeSupportInterface & operator = (const Rotate_FeedbackMessage_TypeSupportInterface &);
            };

            class  Rotate_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef Rotate_FeedbackMessage_DataWriter_var _var_type;

                static Rotate_FeedbackMessage_DataWriter_ptr _duplicate (Rotate_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_FeedbackMessage_& instance_data) = 0;

            protected:
                Rotate_FeedbackMessage_DataWriter () {};
                ~Rotate_FeedbackMessage_DataWriter () {};
            private:
                Rotate_FeedbackMessage_DataWriter (const Rotate_FeedbackMessage_DataWriter &);
                Rotate_FeedbackMessage_DataWriter & operator = (const Rotate_FeedbackMessage_DataWriter &);
            };

            class  Rotate_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef Rotate_FeedbackMessage_DataReader_var _var_type;

                static Rotate_FeedbackMessage_DataReader_ptr _duplicate (Rotate_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_FeedbackMessage_& instance) = 0;

            protected:
                Rotate_FeedbackMessage_DataReader () {};
                ~Rotate_FeedbackMessage_DataReader () {};
            private:
                Rotate_FeedbackMessage_DataReader (const Rotate_FeedbackMessage_DataReader &);
                Rotate_FeedbackMessage_DataReader & operator = (const Rotate_FeedbackMessage_DataReader &);
            };

            class  Rotate_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef Rotate_FeedbackMessage_DataReaderView_var _var_type;

                static Rotate_FeedbackMessage_DataReaderView_ptr _duplicate (Rotate_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_FeedbackMessage_& instance) = 0;

            protected:
                Rotate_FeedbackMessage_DataReaderView () {};
                ~Rotate_FeedbackMessage_DataReaderView () {};
            private:
                Rotate_FeedbackMessage_DataReaderView (const Rotate_FeedbackMessage_DataReaderView &);
                Rotate_FeedbackMessage_DataReaderView & operator = (const Rotate_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
