// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from py_trees_ros_interfaces:msg/BehaviourTree.idl
// generated code does not contain a copyright notice
#include "py_trees_ros_interfaces/msg/behaviour_tree__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `behaviours`
#include "py_trees_ros_interfaces/msg/behaviour__functions.h"
// Member `blackboard_on_visited_path`
#include "diagnostic_msgs/msg/key_value__functions.h"
// Member `blackboard_activity_stream`
#include "rosidl_generator_c/string_functions.h"
// Member `statistics`
#include "py_trees_ros_interfaces/msg/statistics__functions.h"

bool
py_trees_ros_interfaces__msg__BehaviourTree__init(py_trees_ros_interfaces__msg__BehaviourTree * msg)
{
  if (!msg) {
    return false;
  }
  // behaviours
  if (!py_trees_ros_interfaces__msg__Behaviour__Sequence__init(&msg->behaviours, 0)) {
    py_trees_ros_interfaces__msg__BehaviourTree__fini(msg);
    return false;
  }
  // blackboard_on_visited_path
  if (!diagnostic_msgs__msg__KeyValue__Sequence__init(&msg->blackboard_on_visited_path, 0)) {
    py_trees_ros_interfaces__msg__BehaviourTree__fini(msg);
    return false;
  }
  // blackboard_activity_stream
  if (!rosidl_generator_c__String__init(&msg->blackboard_activity_stream)) {
    py_trees_ros_interfaces__msg__BehaviourTree__fini(msg);
    return false;
  }
  // statistics
  if (!py_trees_ros_interfaces__msg__Statistics__init(&msg->statistics)) {
    py_trees_ros_interfaces__msg__BehaviourTree__fini(msg);
    return false;
  }
  return true;
}

void
py_trees_ros_interfaces__msg__BehaviourTree__fini(py_trees_ros_interfaces__msg__BehaviourTree * msg)
{
  if (!msg) {
    return;
  }
  // behaviours
  py_trees_ros_interfaces__msg__Behaviour__Sequence__fini(&msg->behaviours);
  // blackboard_on_visited_path
  diagnostic_msgs__msg__KeyValue__Sequence__fini(&msg->blackboard_on_visited_path);
  // blackboard_activity_stream
  rosidl_generator_c__String__fini(&msg->blackboard_activity_stream);
  // statistics
  py_trees_ros_interfaces__msg__Statistics__fini(&msg->statistics);
}

py_trees_ros_interfaces__msg__BehaviourTree *
py_trees_ros_interfaces__msg__BehaviourTree__create()
{
  py_trees_ros_interfaces__msg__BehaviourTree * msg = (py_trees_ros_interfaces__msg__BehaviourTree *)malloc(sizeof(py_trees_ros_interfaces__msg__BehaviourTree));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(py_trees_ros_interfaces__msg__BehaviourTree));
  bool success = py_trees_ros_interfaces__msg__BehaviourTree__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
py_trees_ros_interfaces__msg__BehaviourTree__destroy(py_trees_ros_interfaces__msg__BehaviourTree * msg)
{
  if (msg) {
    py_trees_ros_interfaces__msg__BehaviourTree__fini(msg);
  }
  free(msg);
}


bool
py_trees_ros_interfaces__msg__BehaviourTree__Sequence__init(py_trees_ros_interfaces__msg__BehaviourTree__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  py_trees_ros_interfaces__msg__BehaviourTree * data = NULL;
  if (size) {
    data = (py_trees_ros_interfaces__msg__BehaviourTree *)calloc(size, sizeof(py_trees_ros_interfaces__msg__BehaviourTree));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = py_trees_ros_interfaces__msg__BehaviourTree__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        py_trees_ros_interfaces__msg__BehaviourTree__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
py_trees_ros_interfaces__msg__BehaviourTree__Sequence__fini(py_trees_ros_interfaces__msg__BehaviourTree__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      py_trees_ros_interfaces__msg__BehaviourTree__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

py_trees_ros_interfaces__msg__BehaviourTree__Sequence *
py_trees_ros_interfaces__msg__BehaviourTree__Sequence__create(size_t size)
{
  py_trees_ros_interfaces__msg__BehaviourTree__Sequence * array = (py_trees_ros_interfaces__msg__BehaviourTree__Sequence *)malloc(sizeof(py_trees_ros_interfaces__msg__BehaviourTree__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = py_trees_ros_interfaces__msg__BehaviourTree__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
py_trees_ros_interfaces__msg__BehaviourTree__Sequence__destroy(py_trees_ros_interfaces__msg__BehaviourTree__Sequence * array)
{
  if (array) {
    py_trees_ros_interfaces__msg__BehaviourTree__Sequence__fini(array);
  }
  free(array);
}
