#ifndef _H_56927319624649C373B450C387F7E2AA_CloseBlackboardWatcher__H_
#define _H_56927319624649C373B450C387F7E2AA_CloseBlackboardWatcher__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  CloseBlackboardWatcher_Request_
            {
                ::DDS::String_mgr topic_name_;
            };

            typedef DDS_DCPSStruct_var<CloseBlackboardWatcher_Request_> CloseBlackboardWatcher_Request__var;
            typedef DDS_DCPSStruct_out < CloseBlackboardWatcher_Request_> CloseBlackboardWatcher_Request__out;

            struct  CloseBlackboardWatcher_Response_
            {
                ::DDS::Boolean result_;
            };

            typedef DDS_DCPSStruct_var<CloseBlackboardWatcher_Response_> CloseBlackboardWatcher_Response__var;
            typedef CloseBlackboardWatcher_Response_& CloseBlackboardWatcher_Response__out;

            struct  Sample_CloseBlackboardWatcher_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::CloseBlackboardWatcher_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_CloseBlackboardWatcher_Request_> Sample_CloseBlackboardWatcher_Request__var;
            typedef DDS_DCPSStruct_out < Sample_CloseBlackboardWatcher_Request_> Sample_CloseBlackboardWatcher_Request__out;

            struct  Sample_CloseBlackboardWatcher_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::CloseBlackboardWatcher_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_CloseBlackboardWatcher_Response_> Sample_CloseBlackboardWatcher_Response__var;
            typedef Sample_CloseBlackboardWatcher_Response_& Sample_CloseBlackboardWatcher_Response__out;

        }

    }

}

#endif /* _H_56927319624649C373B450C387F7E2AA_CloseBlackboardWatcher__H_ */
