#ifndef _H_5507559D03D4BE391009F795AA9E6A30_Statistics__H_
#define _H_5507559D03D4BE391009F795AA9E6A30_Statistics__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            struct  Statistics_
            {
                ::DDS::LongLong count_;
                ::builtin_interfaces::msg::dds_::Time_ stamp_;
                ::DDS::Float tick_duration_;
                ::DDS::Float tick_duration_average_;
                ::DDS::Float tick_duration_variance_;
                ::DDS::Float tick_interval_;
                ::DDS::Float tick_interval_average_;
                ::DDS::Float tick_interval_variance_;
            };

            typedef DDS_DCPSStruct_var<Statistics_> Statistics__var;
            typedef Statistics_& Statistics__out;

        }

    }

}

#endif /* _H_5507559D03D4BE391009F795AA9E6A30_Statistics__H_ */
