#ifndef _H_30F75202D459E5D40243251E6A50868B_StatusReport_DCPS_H_
#define _H_30F75202D459E5D40243251E6A50868B_StatusReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "StatusReport_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class StatusReport_Request_TypeSupportInterface;

            typedef StatusReport_Request_TypeSupportInterface * StatusReport_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Request_TypeSupportInterface> StatusReport_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < StatusReport_Request_TypeSupportInterface> StatusReport_Request_TypeSupportInterface_out;


            class StatusReport_Request_DataWriter;

            typedef StatusReport_Request_DataWriter * StatusReport_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Request_DataWriter> StatusReport_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < StatusReport_Request_DataWriter> StatusReport_Request_DataWriter_out;


            class StatusReport_Request_DataReader;

            typedef StatusReport_Request_DataReader * StatusReport_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Request_DataReader> StatusReport_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < StatusReport_Request_DataReader> StatusReport_Request_DataReader_out;


            class StatusReport_Request_DataReaderView;

            typedef StatusReport_Request_DataReaderView * StatusReport_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Request_DataReaderView> StatusReport_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < StatusReport_Request_DataReaderView> StatusReport_Request_DataReaderView_out;

            struct StatusReport_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < StatusReport_Request_, struct StatusReport_Request_Seq_uniq_> StatusReport_Request_Seq;
            typedef DDS_DCPSSequence_var < StatusReport_Request_Seq> StatusReport_Request_Seq_var;
            typedef DDS_DCPSSequence_out < StatusReport_Request_Seq> StatusReport_Request_Seq_out;

            class  StatusReport_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef StatusReport_Request_TypeSupportInterface_ptr _ptr_type;
                typedef StatusReport_Request_TypeSupportInterface_var _var_type;

                static StatusReport_Request_TypeSupportInterface_ptr _duplicate (StatusReport_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                StatusReport_Request_TypeSupportInterface () {};
                ~StatusReport_Request_TypeSupportInterface () {};
            private:
                StatusReport_Request_TypeSupportInterface (const StatusReport_Request_TypeSupportInterface &);
                StatusReport_Request_TypeSupportInterface & operator = (const StatusReport_Request_TypeSupportInterface &);
            };

            class  StatusReport_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef StatusReport_Request_DataWriter_ptr _ptr_type;
                typedef StatusReport_Request_DataWriter_var _var_type;

                static StatusReport_Request_DataWriter_ptr _duplicate (StatusReport_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const StatusReport_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const StatusReport_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (StatusReport_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StatusReport_Request_& instance_data) = 0;

            protected:
                StatusReport_Request_DataWriter () {};
                ~StatusReport_Request_DataWriter () {};
            private:
                StatusReport_Request_DataWriter (const StatusReport_Request_DataWriter &);
                StatusReport_Request_DataWriter & operator = (const StatusReport_Request_DataWriter &);
            };

            class  StatusReport_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef StatusReport_Request_DataReader_ptr _ptr_type;
                typedef StatusReport_Request_DataReader_var _var_type;

                static StatusReport_Request_DataReader_ptr _duplicate (StatusReport_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StatusReport_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StatusReport_Request_& instance) = 0;

            protected:
                StatusReport_Request_DataReader () {};
                ~StatusReport_Request_DataReader () {};
            private:
                StatusReport_Request_DataReader (const StatusReport_Request_DataReader &);
                StatusReport_Request_DataReader & operator = (const StatusReport_Request_DataReader &);
            };

            class  StatusReport_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef StatusReport_Request_DataReaderView_ptr _ptr_type;
                typedef StatusReport_Request_DataReaderView_var _var_type;

                static StatusReport_Request_DataReaderView_ptr _duplicate (StatusReport_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StatusReport_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StatusReport_Request_& instance) = 0;

            protected:
                StatusReport_Request_DataReaderView () {};
                ~StatusReport_Request_DataReaderView () {};
            private:
                StatusReport_Request_DataReaderView (const StatusReport_Request_DataReaderView &);
                StatusReport_Request_DataReaderView & operator = (const StatusReport_Request_DataReaderView &);
            };
            class StatusReport_Response_TypeSupportInterface;

            typedef StatusReport_Response_TypeSupportInterface * StatusReport_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Response_TypeSupportInterface> StatusReport_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < StatusReport_Response_TypeSupportInterface> StatusReport_Response_TypeSupportInterface_out;


            class StatusReport_Response_DataWriter;

            typedef StatusReport_Response_DataWriter * StatusReport_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Response_DataWriter> StatusReport_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < StatusReport_Response_DataWriter> StatusReport_Response_DataWriter_out;


            class StatusReport_Response_DataReader;

            typedef StatusReport_Response_DataReader * StatusReport_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Response_DataReader> StatusReport_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < StatusReport_Response_DataReader> StatusReport_Response_DataReader_out;


            class StatusReport_Response_DataReaderView;

            typedef StatusReport_Response_DataReaderView * StatusReport_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < StatusReport_Response_DataReaderView> StatusReport_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < StatusReport_Response_DataReaderView> StatusReport_Response_DataReaderView_out;

            struct StatusReport_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < StatusReport_Response_, struct StatusReport_Response_Seq_uniq_> StatusReport_Response_Seq;
            typedef DDS_DCPSSequence_var < StatusReport_Response_Seq> StatusReport_Response_Seq_var;
            typedef DDS_DCPSSequence_out < StatusReport_Response_Seq> StatusReport_Response_Seq_out;

            class  StatusReport_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef StatusReport_Response_TypeSupportInterface_ptr _ptr_type;
                typedef StatusReport_Response_TypeSupportInterface_var _var_type;

                static StatusReport_Response_TypeSupportInterface_ptr _duplicate (StatusReport_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                StatusReport_Response_TypeSupportInterface () {};
                ~StatusReport_Response_TypeSupportInterface () {};
            private:
                StatusReport_Response_TypeSupportInterface (const StatusReport_Response_TypeSupportInterface &);
                StatusReport_Response_TypeSupportInterface & operator = (const StatusReport_Response_TypeSupportInterface &);
            };

            class  StatusReport_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef StatusReport_Response_DataWriter_ptr _ptr_type;
                typedef StatusReport_Response_DataWriter_var _var_type;

                static StatusReport_Response_DataWriter_ptr _duplicate (StatusReport_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const StatusReport_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const StatusReport_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (StatusReport_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StatusReport_Response_& instance_data) = 0;

            protected:
                StatusReport_Response_DataWriter () {};
                ~StatusReport_Response_DataWriter () {};
            private:
                StatusReport_Response_DataWriter (const StatusReport_Response_DataWriter &);
                StatusReport_Response_DataWriter & operator = (const StatusReport_Response_DataWriter &);
            };

            class  StatusReport_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef StatusReport_Response_DataReader_ptr _ptr_type;
                typedef StatusReport_Response_DataReader_var _var_type;

                static StatusReport_Response_DataReader_ptr _duplicate (StatusReport_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StatusReport_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StatusReport_Response_& instance) = 0;

            protected:
                StatusReport_Response_DataReader () {};
                ~StatusReport_Response_DataReader () {};
            private:
                StatusReport_Response_DataReader (const StatusReport_Response_DataReader &);
                StatusReport_Response_DataReader & operator = (const StatusReport_Response_DataReader &);
            };

            class  StatusReport_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef StatusReport_Response_DataReaderView_ptr _ptr_type;
                typedef StatusReport_Response_DataReaderView_var _var_type;

                static StatusReport_Response_DataReaderView_ptr _duplicate (StatusReport_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static StatusReport_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static StatusReport_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static StatusReport_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                StatusReport_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (StatusReport_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const StatusReport_Response_& instance) = 0;

            protected:
                StatusReport_Response_DataReaderView () {};
                ~StatusReport_Response_DataReaderView () {};
            private:
                StatusReport_Response_DataReaderView (const StatusReport_Response_DataReaderView &);
                StatusReport_Response_DataReaderView & operator = (const StatusReport_Response_DataReaderView &);
            };
            class Sample_StatusReport_Request_TypeSupportInterface;

            typedef Sample_StatusReport_Request_TypeSupportInterface * Sample_StatusReport_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Request_TypeSupportInterface> Sample_StatusReport_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Request_TypeSupportInterface> Sample_StatusReport_Request_TypeSupportInterface_out;


            class Sample_StatusReport_Request_DataWriter;

            typedef Sample_StatusReport_Request_DataWriter * Sample_StatusReport_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Request_DataWriter> Sample_StatusReport_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Request_DataWriter> Sample_StatusReport_Request_DataWriter_out;


            class Sample_StatusReport_Request_DataReader;

            typedef Sample_StatusReport_Request_DataReader * Sample_StatusReport_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Request_DataReader> Sample_StatusReport_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Request_DataReader> Sample_StatusReport_Request_DataReader_out;


            class Sample_StatusReport_Request_DataReaderView;

            typedef Sample_StatusReport_Request_DataReaderView * Sample_StatusReport_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Request_DataReaderView> Sample_StatusReport_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Request_DataReaderView> Sample_StatusReport_Request_DataReaderView_out;

            struct Sample_StatusReport_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_StatusReport_Request_, struct Sample_StatusReport_Request_Seq_uniq_> Sample_StatusReport_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_StatusReport_Request_Seq> Sample_StatusReport_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_StatusReport_Request_Seq> Sample_StatusReport_Request_Seq_out;

            class  Sample_StatusReport_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_StatusReport_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_StatusReport_Request_TypeSupportInterface_var _var_type;

                static Sample_StatusReport_Request_TypeSupportInterface_ptr _duplicate (Sample_StatusReport_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_StatusReport_Request_TypeSupportInterface () {};
                ~Sample_StatusReport_Request_TypeSupportInterface () {};
            private:
                Sample_StatusReport_Request_TypeSupportInterface (const Sample_StatusReport_Request_TypeSupportInterface &);
                Sample_StatusReport_Request_TypeSupportInterface & operator = (const Sample_StatusReport_Request_TypeSupportInterface &);
            };

            class  Sample_StatusReport_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_StatusReport_Request_DataWriter_ptr _ptr_type;
                typedef Sample_StatusReport_Request_DataWriter_var _var_type;

                static Sample_StatusReport_Request_DataWriter_ptr _duplicate (Sample_StatusReport_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_StatusReport_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_StatusReport_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_StatusReport_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_StatusReport_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_StatusReport_Request_& instance_data) = 0;

            protected:
                Sample_StatusReport_Request_DataWriter () {};
                ~Sample_StatusReport_Request_DataWriter () {};
            private:
                Sample_StatusReport_Request_DataWriter (const Sample_StatusReport_Request_DataWriter &);
                Sample_StatusReport_Request_DataWriter & operator = (const Sample_StatusReport_Request_DataWriter &);
            };

            class  Sample_StatusReport_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_StatusReport_Request_DataReader_ptr _ptr_type;
                typedef Sample_StatusReport_Request_DataReader_var _var_type;

                static Sample_StatusReport_Request_DataReader_ptr _duplicate (Sample_StatusReport_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_StatusReport_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_StatusReport_Request_& instance) = 0;

            protected:
                Sample_StatusReport_Request_DataReader () {};
                ~Sample_StatusReport_Request_DataReader () {};
            private:
                Sample_StatusReport_Request_DataReader (const Sample_StatusReport_Request_DataReader &);
                Sample_StatusReport_Request_DataReader & operator = (const Sample_StatusReport_Request_DataReader &);
            };

            class  Sample_StatusReport_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_StatusReport_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_StatusReport_Request_DataReaderView_var _var_type;

                static Sample_StatusReport_Request_DataReaderView_ptr _duplicate (Sample_StatusReport_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_StatusReport_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_StatusReport_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_StatusReport_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_StatusReport_Request_& instance) = 0;

            protected:
                Sample_StatusReport_Request_DataReaderView () {};
                ~Sample_StatusReport_Request_DataReaderView () {};
            private:
                Sample_StatusReport_Request_DataReaderView (const Sample_StatusReport_Request_DataReaderView &);
                Sample_StatusReport_Request_DataReaderView & operator = (const Sample_StatusReport_Request_DataReaderView &);
            };
            class Sample_StatusReport_Response_TypeSupportInterface;

            typedef Sample_StatusReport_Response_TypeSupportInterface * Sample_StatusReport_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Response_TypeSupportInterface> Sample_StatusReport_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Response_TypeSupportInterface> Sample_StatusReport_Response_TypeSupportInterface_out;


            class Sample_StatusReport_Response_DataWriter;

            typedef Sample_StatusReport_Response_DataWriter * Sample_StatusReport_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Response_DataWriter> Sample_StatusReport_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Response_DataWriter> Sample_StatusReport_Response_DataWriter_out;


            class Sample_StatusReport_Response_DataReader;

            typedef Sample_StatusReport_Response_DataReader * Sample_StatusReport_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Response_DataReader> Sample_StatusReport_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Response_DataReader> Sample_StatusReport_Response_DataReader_out;


            class Sample_StatusReport_Response_DataReaderView;

            typedef Sample_StatusReport_Response_DataReaderView * Sample_StatusReport_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_StatusReport_Response_DataReaderView> Sample_StatusReport_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_StatusReport_Response_DataReaderView> Sample_StatusReport_Response_DataReaderView_out;

            struct Sample_StatusReport_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_StatusReport_Response_, struct Sample_StatusReport_Response_Seq_uniq_> Sample_StatusReport_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_StatusReport_Response_Seq> Sample_StatusReport_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_StatusReport_Response_Seq> Sample_StatusReport_Response_Seq_out;

            class  Sample_StatusReport_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_StatusReport_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_StatusReport_Response_TypeSupportInterface_var _var_type;

                static Sample_StatusReport_Response_TypeSupportInterface_ptr _duplicate (Sample_StatusReport_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_StatusReport_Response_TypeSupportInterface () {};
                ~Sample_StatusReport_Response_TypeSupportInterface () {};
            private:
                Sample_StatusReport_Response_TypeSupportInterface (const Sample_StatusReport_Response_TypeSupportInterface &);
                Sample_StatusReport_Response_TypeSupportInterface & operator = (const Sample_StatusReport_Response_TypeSupportInterface &);
            };

            class  Sample_StatusReport_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_StatusReport_Response_DataWriter_ptr _ptr_type;
                typedef Sample_StatusReport_Response_DataWriter_var _var_type;

                static Sample_StatusReport_Response_DataWriter_ptr _duplicate (Sample_StatusReport_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_StatusReport_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_StatusReport_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_StatusReport_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_StatusReport_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_StatusReport_Response_& instance_data) = 0;

            protected:
                Sample_StatusReport_Response_DataWriter () {};
                ~Sample_StatusReport_Response_DataWriter () {};
            private:
                Sample_StatusReport_Response_DataWriter (const Sample_StatusReport_Response_DataWriter &);
                Sample_StatusReport_Response_DataWriter & operator = (const Sample_StatusReport_Response_DataWriter &);
            };

            class  Sample_StatusReport_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_StatusReport_Response_DataReader_ptr _ptr_type;
                typedef Sample_StatusReport_Response_DataReader_var _var_type;

                static Sample_StatusReport_Response_DataReader_ptr _duplicate (Sample_StatusReport_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_StatusReport_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_StatusReport_Response_& instance) = 0;

            protected:
                Sample_StatusReport_Response_DataReader () {};
                ~Sample_StatusReport_Response_DataReader () {};
            private:
                Sample_StatusReport_Response_DataReader (const Sample_StatusReport_Response_DataReader &);
                Sample_StatusReport_Response_DataReader & operator = (const Sample_StatusReport_Response_DataReader &);
            };

            class  Sample_StatusReport_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_StatusReport_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_StatusReport_Response_DataReaderView_var _var_type;

                static Sample_StatusReport_Response_DataReaderView_ptr _duplicate (Sample_StatusReport_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_StatusReport_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_StatusReport_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_StatusReport_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_StatusReport_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_StatusReport_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_StatusReport_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_StatusReport_Response_& instance) = 0;

            protected:
                Sample_StatusReport_Response_DataReaderView () {};
                ~Sample_StatusReport_Response_DataReaderView () {};
            private:
                Sample_StatusReport_Response_DataReaderView (const Sample_StatusReport_Response_DataReaderView &);
                Sample_StatusReport_Response_DataReaderView & operator = (const Sample_StatusReport_Response_DataReaderView &);
            };
        }

    }

}

#endif
